/* Autogenerated: src/ExtractionOCaml/word_by_word_montgomery --lang=Rust p224 '2^224 - 2^96 + 1' 64 */
/* curve description: p224 */
/* requested operations: (all) */
/* m = 0xffffffffffffffffffffffffffffffff000000000000000000000001 (from "2^224 - 2^96 + 1") */
/* machine_wordsize = 64 (from "64") */
/*                                                                    */
/* NOTE: In addition to the bounds specified above each function, all */
/*   functions synthesized for this Montgomery arithmetic require the */
/*   input to be strictly less than the prime modulus (m), and also   */
/*   require the input to be in the unique saturated representation.  */
/*   All functions also ensure that these two properties are true of  */
/*   return values.                                                   */

#![allow(unused_parens)]
#[allow(non_camel_case_types)]

pub type fiat_p224_u1 = u8;
pub type fiat_p224_i1 = i8;
pub type fiat_p224_u2 = u8;
pub type fiat_p224_i2 = i8;
pub type fiat_p224_u128 = u128;
pub type fiat_p224_i128 = i128;


/*
 * The function fiat_p224_addcarryx_u64 is an addition with carry.
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^64
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
#[inline]
pub fn fiat_p224_addcarryx_u64(out1: &mut u64, out2: &mut fiat_p224_u1, arg1: fiat_p224_u1, arg2: u64, arg3: u64) -> () {
  let x1: fiat_p224_u128 = (((arg1 as fiat_p224_u128) + (arg2 as fiat_p224_u128)) + (arg3 as fiat_p224_u128));
  let x2: u64 = ((x1 & (0xffffffffffffffff as fiat_p224_u128)) as u64);
  let x3: fiat_p224_u1 = ((x1 >> 64) as fiat_p224_u1);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p224_subborrowx_u64 is a subtraction with borrow.
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^64
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
#[inline]
pub fn fiat_p224_subborrowx_u64(out1: &mut u64, out2: &mut fiat_p224_u1, arg1: fiat_p224_u1, arg2: u64, arg3: u64) -> () {
  let x1: fiat_p224_i128 = (((arg2 as fiat_p224_i128) - (arg1 as fiat_p224_i128)) - (arg3 as fiat_p224_i128));
  let x2: fiat_p224_i1 = ((x1 >> 64) as fiat_p224_i1);
  let x3: u64 = ((x1 & (0xffffffffffffffff as fiat_p224_i128)) as u64);
  *out1 = x3;
  *out2 = (((0x0 as fiat_p224_i2) - (x2 as fiat_p224_i2)) as fiat_p224_u1);
}

/*
 * The function fiat_p224_mulx_u64 is a multiplication, returning the full double-width result.
 * Postconditions:
 *   out1 = (arg1 * arg2) mod 2^64
 *   out2 = ⌊arg1 * arg2 / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffffffffffff]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0xffffffffffffffff]
 */
#[inline]
pub fn fiat_p224_mulx_u64(out1: &mut u64, out2: &mut u64, arg1: u64, arg2: u64) -> () {
  let x1: fiat_p224_u128 = ((arg1 as fiat_p224_u128) * (arg2 as fiat_p224_u128));
  let x2: u64 = ((x1 & (0xffffffffffffffff as fiat_p224_u128)) as u64);
  let x3: u64 = ((x1 >> 64) as u64);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p224_cmovznz_u64 is a single-word conditional move.
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
#[inline]
pub fn fiat_p224_cmovznz_u64(out1: &mut u64, arg1: fiat_p224_u1, arg2: u64, arg3: u64) -> () {
  let x1: fiat_p224_u1 = (!(!arg1));
  let x2: u64 = ((((((0x0 as fiat_p224_i2) - (x1 as fiat_p224_i2)) as fiat_p224_i1) as fiat_p224_i128) & (0xffffffffffffffff as fiat_p224_i128)) as u64);
  let x3: u64 = ((x2 & arg3) | ((!x2) & arg2));
  *out1 = x3;
}

/*
 * The function fiat_p224_mul multiplies two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p224_mul(out1: &mut [u64; 4], arg1: &[u64; 4], arg2: &[u64; 4]) -> () {
  let x1: u64 = (arg1[1]);
  let x2: u64 = (arg1[2]);
  let x3: u64 = (arg1[3]);
  let x4: u64 = (arg1[0]);
  let mut x5: u64 = 0;
  let mut x6: u64 = 0;
  fiat_p224_mulx_u64(&mut x5, &mut x6, x4, (arg2[3]));
  let mut x7: u64 = 0;
  let mut x8: u64 = 0;
  fiat_p224_mulx_u64(&mut x7, &mut x8, x4, (arg2[2]));
  let mut x9: u64 = 0;
  let mut x10: u64 = 0;
  fiat_p224_mulx_u64(&mut x9, &mut x10, x4, (arg2[1]));
  let mut x11: u64 = 0;
  let mut x12: u64 = 0;
  fiat_p224_mulx_u64(&mut x11, &mut x12, x4, (arg2[0]));
  let mut x13: u64 = 0;
  let mut x14: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x13, &mut x14, 0x0, x12, x9);
  let mut x15: u64 = 0;
  let mut x16: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x15, &mut x16, x14, x10, x7);
  let mut x17: u64 = 0;
  let mut x18: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x17, &mut x18, x16, x8, x5);
  let mut x19: u64 = 0;
  let mut x20: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x19, &mut x20, x18, x6, (0x0 as u64));
  let mut x21: u64 = 0;
  let mut x22: u64 = 0;
  fiat_p224_mulx_u64(&mut x21, &mut x22, x11, 0xffffffffffffffff);
  let mut x23: u64 = 0;
  let mut x24: u64 = 0;
  fiat_p224_mulx_u64(&mut x23, &mut x24, x21, 0xffffffff);
  let mut x25: u64 = 0;
  let mut x26: u64 = 0;
  fiat_p224_mulx_u64(&mut x25, &mut x26, x21, 0xffffffffffffffff);
  let mut x27: u64 = 0;
  let mut x28: u64 = 0;
  fiat_p224_mulx_u64(&mut x27, &mut x28, x21, 0xffffffff00000000);
  let mut x29: u64 = 0;
  let mut x30: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x29, &mut x30, 0x0, x28, x25);
  let mut x31: u64 = 0;
  let mut x32: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x31, &mut x32, x30, x26, x23);
  let mut x33: u64 = 0;
  let mut x34: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x33, &mut x34, x32, x24, (0x0 as u64));
  let mut x35: u64 = 0;
  let mut x36: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x35, &mut x36, 0x0, x11, x21);
  let mut x37: u64 = 0;
  let mut x38: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x37, &mut x38, x36, x13, x27);
  let mut x39: u64 = 0;
  let mut x40: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x39, &mut x40, x38, x15, x29);
  let mut x41: u64 = 0;
  let mut x42: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x41, &mut x42, x40, x17, x31);
  let mut x43: u64 = 0;
  let mut x44: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x43, &mut x44, x42, x19, x33);
  let mut x45: u64 = 0;
  let mut x46: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x45, &mut x46, x44, (0x0 as u64), (0x0 as u64));
  let mut x47: u64 = 0;
  let mut x48: u64 = 0;
  fiat_p224_mulx_u64(&mut x47, &mut x48, x1, (arg2[3]));
  let mut x49: u64 = 0;
  let mut x50: u64 = 0;
  fiat_p224_mulx_u64(&mut x49, &mut x50, x1, (arg2[2]));
  let mut x51: u64 = 0;
  let mut x52: u64 = 0;
  fiat_p224_mulx_u64(&mut x51, &mut x52, x1, (arg2[1]));
  let mut x53: u64 = 0;
  let mut x54: u64 = 0;
  fiat_p224_mulx_u64(&mut x53, &mut x54, x1, (arg2[0]));
  let mut x55: u64 = 0;
  let mut x56: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x55, &mut x56, 0x0, x54, x51);
  let mut x57: u64 = 0;
  let mut x58: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x57, &mut x58, x56, x52, x49);
  let mut x59: u64 = 0;
  let mut x60: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x59, &mut x60, x58, x50, x47);
  let mut x61: u64 = 0;
  let mut x62: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x61, &mut x62, x60, x48, (0x0 as u64));
  let mut x63: u64 = 0;
  let mut x64: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x63, &mut x64, 0x0, x37, x53);
  let mut x65: u64 = 0;
  let mut x66: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x65, &mut x66, x64, x39, x55);
  let mut x67: u64 = 0;
  let mut x68: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x67, &mut x68, x66, x41, x57);
  let mut x69: u64 = 0;
  let mut x70: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x69, &mut x70, x68, x43, x59);
  let mut x71: u64 = 0;
  let mut x72: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x71, &mut x72, x70, ((x45 as fiat_p224_u1) as u64), x61);
  let mut x73: u64 = 0;
  let mut x74: u64 = 0;
  fiat_p224_mulx_u64(&mut x73, &mut x74, x63, 0xffffffffffffffff);
  let mut x75: u64 = 0;
  let mut x76: u64 = 0;
  fiat_p224_mulx_u64(&mut x75, &mut x76, x73, 0xffffffff);
  let mut x77: u64 = 0;
  let mut x78: u64 = 0;
  fiat_p224_mulx_u64(&mut x77, &mut x78, x73, 0xffffffffffffffff);
  let mut x79: u64 = 0;
  let mut x80: u64 = 0;
  fiat_p224_mulx_u64(&mut x79, &mut x80, x73, 0xffffffff00000000);
  let mut x81: u64 = 0;
  let mut x82: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x81, &mut x82, 0x0, x80, x77);
  let mut x83: u64 = 0;
  let mut x84: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x83, &mut x84, x82, x78, x75);
  let mut x85: u64 = 0;
  let mut x86: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x85, &mut x86, x84, x76, (0x0 as u64));
  let mut x87: u64 = 0;
  let mut x88: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x87, &mut x88, 0x0, x63, x73);
  let mut x89: u64 = 0;
  let mut x90: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x89, &mut x90, x88, x65, x79);
  let mut x91: u64 = 0;
  let mut x92: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x91, &mut x92, x90, x67, x81);
  let mut x93: u64 = 0;
  let mut x94: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x93, &mut x94, x92, x69, x83);
  let mut x95: u64 = 0;
  let mut x96: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x95, &mut x96, x94, x71, x85);
  let mut x97: u64 = 0;
  let mut x98: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x97, &mut x98, x96, (x72 as u64), (0x0 as u64));
  let mut x99: u64 = 0;
  let mut x100: u64 = 0;
  fiat_p224_mulx_u64(&mut x99, &mut x100, x2, (arg2[3]));
  let mut x101: u64 = 0;
  let mut x102: u64 = 0;
  fiat_p224_mulx_u64(&mut x101, &mut x102, x2, (arg2[2]));
  let mut x103: u64 = 0;
  let mut x104: u64 = 0;
  fiat_p224_mulx_u64(&mut x103, &mut x104, x2, (arg2[1]));
  let mut x105: u64 = 0;
  let mut x106: u64 = 0;
  fiat_p224_mulx_u64(&mut x105, &mut x106, x2, (arg2[0]));
  let mut x107: u64 = 0;
  let mut x108: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x107, &mut x108, 0x0, x106, x103);
  let mut x109: u64 = 0;
  let mut x110: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x109, &mut x110, x108, x104, x101);
  let mut x111: u64 = 0;
  let mut x112: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x111, &mut x112, x110, x102, x99);
  let mut x113: u64 = 0;
  let mut x114: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x113, &mut x114, x112, x100, (0x0 as u64));
  let mut x115: u64 = 0;
  let mut x116: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x115, &mut x116, 0x0, x89, x105);
  let mut x117: u64 = 0;
  let mut x118: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x117, &mut x118, x116, x91, x107);
  let mut x119: u64 = 0;
  let mut x120: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x119, &mut x120, x118, x93, x109);
  let mut x121: u64 = 0;
  let mut x122: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x121, &mut x122, x120, x95, x111);
  let mut x123: u64 = 0;
  let mut x124: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x123, &mut x124, x122, x97, x113);
  let mut x125: u64 = 0;
  let mut x126: u64 = 0;
  fiat_p224_mulx_u64(&mut x125, &mut x126, x115, 0xffffffffffffffff);
  let mut x127: u64 = 0;
  let mut x128: u64 = 0;
  fiat_p224_mulx_u64(&mut x127, &mut x128, x125, 0xffffffff);
  let mut x129: u64 = 0;
  let mut x130: u64 = 0;
  fiat_p224_mulx_u64(&mut x129, &mut x130, x125, 0xffffffffffffffff);
  let mut x131: u64 = 0;
  let mut x132: u64 = 0;
  fiat_p224_mulx_u64(&mut x131, &mut x132, x125, 0xffffffff00000000);
  let mut x133: u64 = 0;
  let mut x134: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x133, &mut x134, 0x0, x132, x129);
  let mut x135: u64 = 0;
  let mut x136: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x135, &mut x136, x134, x130, x127);
  let mut x137: u64 = 0;
  let mut x138: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x137, &mut x138, x136, x128, (0x0 as u64));
  let mut x139: u64 = 0;
  let mut x140: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x139, &mut x140, 0x0, x115, x125);
  let mut x141: u64 = 0;
  let mut x142: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x141, &mut x142, x140, x117, x131);
  let mut x143: u64 = 0;
  let mut x144: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x143, &mut x144, x142, x119, x133);
  let mut x145: u64 = 0;
  let mut x146: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x145, &mut x146, x144, x121, x135);
  let mut x147: u64 = 0;
  let mut x148: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x147, &mut x148, x146, x123, x137);
  let mut x149: u64 = 0;
  let mut x150: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x149, &mut x150, x148, (x124 as u64), (0x0 as u64));
  let mut x151: u64 = 0;
  let mut x152: u64 = 0;
  fiat_p224_mulx_u64(&mut x151, &mut x152, x3, (arg2[3]));
  let mut x153: u64 = 0;
  let mut x154: u64 = 0;
  fiat_p224_mulx_u64(&mut x153, &mut x154, x3, (arg2[2]));
  let mut x155: u64 = 0;
  let mut x156: u64 = 0;
  fiat_p224_mulx_u64(&mut x155, &mut x156, x3, (arg2[1]));
  let mut x157: u64 = 0;
  let mut x158: u64 = 0;
  fiat_p224_mulx_u64(&mut x157, &mut x158, x3, (arg2[0]));
  let mut x159: u64 = 0;
  let mut x160: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x159, &mut x160, 0x0, x158, x155);
  let mut x161: u64 = 0;
  let mut x162: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x161, &mut x162, x160, x156, x153);
  let mut x163: u64 = 0;
  let mut x164: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x163, &mut x164, x162, x154, x151);
  let mut x165: u64 = 0;
  let mut x166: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x165, &mut x166, x164, x152, (0x0 as u64));
  let mut x167: u64 = 0;
  let mut x168: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x167, &mut x168, 0x0, x141, x157);
  let mut x169: u64 = 0;
  let mut x170: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x169, &mut x170, x168, x143, x159);
  let mut x171: u64 = 0;
  let mut x172: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x171, &mut x172, x170, x145, x161);
  let mut x173: u64 = 0;
  let mut x174: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x173, &mut x174, x172, x147, x163);
  let mut x175: u64 = 0;
  let mut x176: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x175, &mut x176, x174, x149, x165);
  let mut x177: u64 = 0;
  let mut x178: u64 = 0;
  fiat_p224_mulx_u64(&mut x177, &mut x178, x167, 0xffffffffffffffff);
  let mut x179: u64 = 0;
  let mut x180: u64 = 0;
  fiat_p224_mulx_u64(&mut x179, &mut x180, x177, 0xffffffff);
  let mut x181: u64 = 0;
  let mut x182: u64 = 0;
  fiat_p224_mulx_u64(&mut x181, &mut x182, x177, 0xffffffffffffffff);
  let mut x183: u64 = 0;
  let mut x184: u64 = 0;
  fiat_p224_mulx_u64(&mut x183, &mut x184, x177, 0xffffffff00000000);
  let mut x185: u64 = 0;
  let mut x186: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x185, &mut x186, 0x0, x184, x181);
  let mut x187: u64 = 0;
  let mut x188: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x187, &mut x188, x186, x182, x179);
  let mut x189: u64 = 0;
  let mut x190: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x189, &mut x190, x188, x180, (0x0 as u64));
  let mut x191: u64 = 0;
  let mut x192: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x191, &mut x192, 0x0, x167, x177);
  let mut x193: u64 = 0;
  let mut x194: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x193, &mut x194, x192, x169, x183);
  let mut x195: u64 = 0;
  let mut x196: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x195, &mut x196, x194, x171, x185);
  let mut x197: u64 = 0;
  let mut x198: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x197, &mut x198, x196, x173, x187);
  let mut x199: u64 = 0;
  let mut x200: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x199, &mut x200, x198, x175, x189);
  let mut x201: u64 = 0;
  let mut x202: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x201, &mut x202, x200, (x176 as u64), (0x0 as u64));
  let mut x203: u64 = 0;
  let mut x204: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x203, &mut x204, 0x0, x193, (0x1 as u64));
  let mut x205: u64 = 0;
  let mut x206: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x205, &mut x206, x204, x195, 0xffffffff00000000);
  let mut x207: u64 = 0;
  let mut x208: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x207, &mut x208, x206, x197, 0xffffffffffffffff);
  let mut x209: u64 = 0;
  let mut x210: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x209, &mut x210, x208, x199, (0xffffffff as u64));
  let mut x211: u64 = 0;
  let mut x212: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x211, &mut x212, x210, x201, (0x0 as u64));
  let mut x213: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x213, x212, x203, x193);
  let mut x214: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x214, x212, x205, x195);
  let mut x215: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x215, x212, x207, x197);
  let mut x216: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x216, x212, x209, x199);
  out1[0] = x213;
  out1[1] = x214;
  out1[2] = x215;
  out1[3] = x216;
}

/*
 * The function fiat_p224_square squares a field element in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p224_square(out1: &mut [u64; 4], arg1: &[u64; 4]) -> () {
  let x1: u64 = (arg1[1]);
  let x2: u64 = (arg1[2]);
  let x3: u64 = (arg1[3]);
  let x4: u64 = (arg1[0]);
  let mut x5: u64 = 0;
  let mut x6: u64 = 0;
  fiat_p224_mulx_u64(&mut x5, &mut x6, x4, (arg1[3]));
  let mut x7: u64 = 0;
  let mut x8: u64 = 0;
  fiat_p224_mulx_u64(&mut x7, &mut x8, x4, (arg1[2]));
  let mut x9: u64 = 0;
  let mut x10: u64 = 0;
  fiat_p224_mulx_u64(&mut x9, &mut x10, x4, (arg1[1]));
  let mut x11: u64 = 0;
  let mut x12: u64 = 0;
  fiat_p224_mulx_u64(&mut x11, &mut x12, x4, (arg1[0]));
  let mut x13: u64 = 0;
  let mut x14: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x13, &mut x14, 0x0, x12, x9);
  let mut x15: u64 = 0;
  let mut x16: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x15, &mut x16, x14, x10, x7);
  let mut x17: u64 = 0;
  let mut x18: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x17, &mut x18, x16, x8, x5);
  let mut x19: u64 = 0;
  let mut x20: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x19, &mut x20, x18, x6, (0x0 as u64));
  let mut x21: u64 = 0;
  let mut x22: u64 = 0;
  fiat_p224_mulx_u64(&mut x21, &mut x22, x11, 0xffffffffffffffff);
  let mut x23: u64 = 0;
  let mut x24: u64 = 0;
  fiat_p224_mulx_u64(&mut x23, &mut x24, x21, 0xffffffff);
  let mut x25: u64 = 0;
  let mut x26: u64 = 0;
  fiat_p224_mulx_u64(&mut x25, &mut x26, x21, 0xffffffffffffffff);
  let mut x27: u64 = 0;
  let mut x28: u64 = 0;
  fiat_p224_mulx_u64(&mut x27, &mut x28, x21, 0xffffffff00000000);
  let mut x29: u64 = 0;
  let mut x30: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x29, &mut x30, 0x0, x28, x25);
  let mut x31: u64 = 0;
  let mut x32: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x31, &mut x32, x30, x26, x23);
  let mut x33: u64 = 0;
  let mut x34: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x33, &mut x34, x32, x24, (0x0 as u64));
  let mut x35: u64 = 0;
  let mut x36: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x35, &mut x36, 0x0, x11, x21);
  let mut x37: u64 = 0;
  let mut x38: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x37, &mut x38, x36, x13, x27);
  let mut x39: u64 = 0;
  let mut x40: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x39, &mut x40, x38, x15, x29);
  let mut x41: u64 = 0;
  let mut x42: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x41, &mut x42, x40, x17, x31);
  let mut x43: u64 = 0;
  let mut x44: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x43, &mut x44, x42, x19, x33);
  let mut x45: u64 = 0;
  let mut x46: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x45, &mut x46, x44, (0x0 as u64), (0x0 as u64));
  let mut x47: u64 = 0;
  let mut x48: u64 = 0;
  fiat_p224_mulx_u64(&mut x47, &mut x48, x1, (arg1[3]));
  let mut x49: u64 = 0;
  let mut x50: u64 = 0;
  fiat_p224_mulx_u64(&mut x49, &mut x50, x1, (arg1[2]));
  let mut x51: u64 = 0;
  let mut x52: u64 = 0;
  fiat_p224_mulx_u64(&mut x51, &mut x52, x1, (arg1[1]));
  let mut x53: u64 = 0;
  let mut x54: u64 = 0;
  fiat_p224_mulx_u64(&mut x53, &mut x54, x1, (arg1[0]));
  let mut x55: u64 = 0;
  let mut x56: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x55, &mut x56, 0x0, x54, x51);
  let mut x57: u64 = 0;
  let mut x58: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x57, &mut x58, x56, x52, x49);
  let mut x59: u64 = 0;
  let mut x60: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x59, &mut x60, x58, x50, x47);
  let mut x61: u64 = 0;
  let mut x62: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x61, &mut x62, x60, x48, (0x0 as u64));
  let mut x63: u64 = 0;
  let mut x64: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x63, &mut x64, 0x0, x37, x53);
  let mut x65: u64 = 0;
  let mut x66: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x65, &mut x66, x64, x39, x55);
  let mut x67: u64 = 0;
  let mut x68: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x67, &mut x68, x66, x41, x57);
  let mut x69: u64 = 0;
  let mut x70: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x69, &mut x70, x68, x43, x59);
  let mut x71: u64 = 0;
  let mut x72: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x71, &mut x72, x70, ((x45 as fiat_p224_u1) as u64), x61);
  let mut x73: u64 = 0;
  let mut x74: u64 = 0;
  fiat_p224_mulx_u64(&mut x73, &mut x74, x63, 0xffffffffffffffff);
  let mut x75: u64 = 0;
  let mut x76: u64 = 0;
  fiat_p224_mulx_u64(&mut x75, &mut x76, x73, 0xffffffff);
  let mut x77: u64 = 0;
  let mut x78: u64 = 0;
  fiat_p224_mulx_u64(&mut x77, &mut x78, x73, 0xffffffffffffffff);
  let mut x79: u64 = 0;
  let mut x80: u64 = 0;
  fiat_p224_mulx_u64(&mut x79, &mut x80, x73, 0xffffffff00000000);
  let mut x81: u64 = 0;
  let mut x82: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x81, &mut x82, 0x0, x80, x77);
  let mut x83: u64 = 0;
  let mut x84: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x83, &mut x84, x82, x78, x75);
  let mut x85: u64 = 0;
  let mut x86: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x85, &mut x86, x84, x76, (0x0 as u64));
  let mut x87: u64 = 0;
  let mut x88: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x87, &mut x88, 0x0, x63, x73);
  let mut x89: u64 = 0;
  let mut x90: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x89, &mut x90, x88, x65, x79);
  let mut x91: u64 = 0;
  let mut x92: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x91, &mut x92, x90, x67, x81);
  let mut x93: u64 = 0;
  let mut x94: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x93, &mut x94, x92, x69, x83);
  let mut x95: u64 = 0;
  let mut x96: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x95, &mut x96, x94, x71, x85);
  let mut x97: u64 = 0;
  let mut x98: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x97, &mut x98, x96, (x72 as u64), (0x0 as u64));
  let mut x99: u64 = 0;
  let mut x100: u64 = 0;
  fiat_p224_mulx_u64(&mut x99, &mut x100, x2, (arg1[3]));
  let mut x101: u64 = 0;
  let mut x102: u64 = 0;
  fiat_p224_mulx_u64(&mut x101, &mut x102, x2, (arg1[2]));
  let mut x103: u64 = 0;
  let mut x104: u64 = 0;
  fiat_p224_mulx_u64(&mut x103, &mut x104, x2, (arg1[1]));
  let mut x105: u64 = 0;
  let mut x106: u64 = 0;
  fiat_p224_mulx_u64(&mut x105, &mut x106, x2, (arg1[0]));
  let mut x107: u64 = 0;
  let mut x108: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x107, &mut x108, 0x0, x106, x103);
  let mut x109: u64 = 0;
  let mut x110: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x109, &mut x110, x108, x104, x101);
  let mut x111: u64 = 0;
  let mut x112: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x111, &mut x112, x110, x102, x99);
  let mut x113: u64 = 0;
  let mut x114: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x113, &mut x114, x112, x100, (0x0 as u64));
  let mut x115: u64 = 0;
  let mut x116: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x115, &mut x116, 0x0, x89, x105);
  let mut x117: u64 = 0;
  let mut x118: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x117, &mut x118, x116, x91, x107);
  let mut x119: u64 = 0;
  let mut x120: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x119, &mut x120, x118, x93, x109);
  let mut x121: u64 = 0;
  let mut x122: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x121, &mut x122, x120, x95, x111);
  let mut x123: u64 = 0;
  let mut x124: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x123, &mut x124, x122, x97, x113);
  let mut x125: u64 = 0;
  let mut x126: u64 = 0;
  fiat_p224_mulx_u64(&mut x125, &mut x126, x115, 0xffffffffffffffff);
  let mut x127: u64 = 0;
  let mut x128: u64 = 0;
  fiat_p224_mulx_u64(&mut x127, &mut x128, x125, 0xffffffff);
  let mut x129: u64 = 0;
  let mut x130: u64 = 0;
  fiat_p224_mulx_u64(&mut x129, &mut x130, x125, 0xffffffffffffffff);
  let mut x131: u64 = 0;
  let mut x132: u64 = 0;
  fiat_p224_mulx_u64(&mut x131, &mut x132, x125, 0xffffffff00000000);
  let mut x133: u64 = 0;
  let mut x134: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x133, &mut x134, 0x0, x132, x129);
  let mut x135: u64 = 0;
  let mut x136: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x135, &mut x136, x134, x130, x127);
  let mut x137: u64 = 0;
  let mut x138: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x137, &mut x138, x136, x128, (0x0 as u64));
  let mut x139: u64 = 0;
  let mut x140: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x139, &mut x140, 0x0, x115, x125);
  let mut x141: u64 = 0;
  let mut x142: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x141, &mut x142, x140, x117, x131);
  let mut x143: u64 = 0;
  let mut x144: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x143, &mut x144, x142, x119, x133);
  let mut x145: u64 = 0;
  let mut x146: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x145, &mut x146, x144, x121, x135);
  let mut x147: u64 = 0;
  let mut x148: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x147, &mut x148, x146, x123, x137);
  let mut x149: u64 = 0;
  let mut x150: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x149, &mut x150, x148, (x124 as u64), (0x0 as u64));
  let mut x151: u64 = 0;
  let mut x152: u64 = 0;
  fiat_p224_mulx_u64(&mut x151, &mut x152, x3, (arg1[3]));
  let mut x153: u64 = 0;
  let mut x154: u64 = 0;
  fiat_p224_mulx_u64(&mut x153, &mut x154, x3, (arg1[2]));
  let mut x155: u64 = 0;
  let mut x156: u64 = 0;
  fiat_p224_mulx_u64(&mut x155, &mut x156, x3, (arg1[1]));
  let mut x157: u64 = 0;
  let mut x158: u64 = 0;
  fiat_p224_mulx_u64(&mut x157, &mut x158, x3, (arg1[0]));
  let mut x159: u64 = 0;
  let mut x160: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x159, &mut x160, 0x0, x158, x155);
  let mut x161: u64 = 0;
  let mut x162: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x161, &mut x162, x160, x156, x153);
  let mut x163: u64 = 0;
  let mut x164: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x163, &mut x164, x162, x154, x151);
  let mut x165: u64 = 0;
  let mut x166: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x165, &mut x166, x164, x152, (0x0 as u64));
  let mut x167: u64 = 0;
  let mut x168: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x167, &mut x168, 0x0, x141, x157);
  let mut x169: u64 = 0;
  let mut x170: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x169, &mut x170, x168, x143, x159);
  let mut x171: u64 = 0;
  let mut x172: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x171, &mut x172, x170, x145, x161);
  let mut x173: u64 = 0;
  let mut x174: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x173, &mut x174, x172, x147, x163);
  let mut x175: u64 = 0;
  let mut x176: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x175, &mut x176, x174, x149, x165);
  let mut x177: u64 = 0;
  let mut x178: u64 = 0;
  fiat_p224_mulx_u64(&mut x177, &mut x178, x167, 0xffffffffffffffff);
  let mut x179: u64 = 0;
  let mut x180: u64 = 0;
  fiat_p224_mulx_u64(&mut x179, &mut x180, x177, 0xffffffff);
  let mut x181: u64 = 0;
  let mut x182: u64 = 0;
  fiat_p224_mulx_u64(&mut x181, &mut x182, x177, 0xffffffffffffffff);
  let mut x183: u64 = 0;
  let mut x184: u64 = 0;
  fiat_p224_mulx_u64(&mut x183, &mut x184, x177, 0xffffffff00000000);
  let mut x185: u64 = 0;
  let mut x186: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x185, &mut x186, 0x0, x184, x181);
  let mut x187: u64 = 0;
  let mut x188: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x187, &mut x188, x186, x182, x179);
  let mut x189: u64 = 0;
  let mut x190: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x189, &mut x190, x188, x180, (0x0 as u64));
  let mut x191: u64 = 0;
  let mut x192: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x191, &mut x192, 0x0, x167, x177);
  let mut x193: u64 = 0;
  let mut x194: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x193, &mut x194, x192, x169, x183);
  let mut x195: u64 = 0;
  let mut x196: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x195, &mut x196, x194, x171, x185);
  let mut x197: u64 = 0;
  let mut x198: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x197, &mut x198, x196, x173, x187);
  let mut x199: u64 = 0;
  let mut x200: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x199, &mut x200, x198, x175, x189);
  let mut x201: u64 = 0;
  let mut x202: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x201, &mut x202, x200, (x176 as u64), (0x0 as u64));
  let mut x203: u64 = 0;
  let mut x204: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x203, &mut x204, 0x0, x193, (0x1 as u64));
  let mut x205: u64 = 0;
  let mut x206: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x205, &mut x206, x204, x195, 0xffffffff00000000);
  let mut x207: u64 = 0;
  let mut x208: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x207, &mut x208, x206, x197, 0xffffffffffffffff);
  let mut x209: u64 = 0;
  let mut x210: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x209, &mut x210, x208, x199, (0xffffffff as u64));
  let mut x211: u64 = 0;
  let mut x212: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x211, &mut x212, x210, x201, (0x0 as u64));
  let mut x213: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x213, x212, x203, x193);
  let mut x214: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x214, x212, x205, x195);
  let mut x215: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x215, x212, x207, x197);
  let mut x216: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x216, x212, x209, x199);
  out1[0] = x213;
  out1[1] = x214;
  out1[2] = x215;
  out1[3] = x216;
}

/*
 * The function fiat_p224_add adds two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p224_add(out1: &mut [u64; 4], arg1: &[u64; 4], arg2: &[u64; 4]) -> () {
  let mut x1: u64 = 0;
  let mut x2: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x1, &mut x2, 0x0, (arg1[0]), (arg2[0]));
  let mut x3: u64 = 0;
  let mut x4: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x3, &mut x4, x2, (arg1[1]), (arg2[1]));
  let mut x5: u64 = 0;
  let mut x6: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x5, &mut x6, x4, (arg1[2]), (arg2[2]));
  let mut x7: u64 = 0;
  let mut x8: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x7, &mut x8, x6, (arg1[3]), (arg2[3]));
  let mut x9: u64 = 0;
  let mut x10: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x9, &mut x10, 0x0, x1, (0x1 as u64));
  let mut x11: u64 = 0;
  let mut x12: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x11, &mut x12, x10, x3, 0xffffffff00000000);
  let mut x13: u64 = 0;
  let mut x14: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x13, &mut x14, x12, x5, 0xffffffffffffffff);
  let mut x15: u64 = 0;
  let mut x16: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x15, &mut x16, x14, x7, (0xffffffff as u64));
  let mut x17: u64 = 0;
  let mut x18: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x17, &mut x18, x16, (x8 as u64), (0x0 as u64));
  let mut x19: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x19, x18, x9, x1);
  let mut x20: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x20, x18, x11, x3);
  let mut x21: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x21, x18, x13, x5);
  let mut x22: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x22, x18, x15, x7);
  out1[0] = x19;
  out1[1] = x20;
  out1[2] = x21;
  out1[3] = x22;
}

/*
 * The function fiat_p224_sub subtracts two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p224_sub(out1: &mut [u64; 4], arg1: &[u64; 4], arg2: &[u64; 4]) -> () {
  let mut x1: u64 = 0;
  let mut x2: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x1, &mut x2, 0x0, (arg1[0]), (arg2[0]));
  let mut x3: u64 = 0;
  let mut x4: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x3, &mut x4, x2, (arg1[1]), (arg2[1]));
  let mut x5: u64 = 0;
  let mut x6: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x5, &mut x6, x4, (arg1[2]), (arg2[2]));
  let mut x7: u64 = 0;
  let mut x8: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x7, &mut x8, x6, (arg1[3]), (arg2[3]));
  let mut x9: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x9, x8, (0x0 as u64), 0xffffffffffffffff);
  let mut x10: u64 = 0;
  let mut x11: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x10, &mut x11, 0x0, x1, (((x9 & (0x1 as u64)) as fiat_p224_u1) as u64));
  let mut x12: u64 = 0;
  let mut x13: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x12, &mut x13, x11, x3, (x9 & 0xffffffff00000000));
  let mut x14: u64 = 0;
  let mut x15: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x14, &mut x15, x13, x5, (x9 & 0xffffffffffffffff));
  let mut x16: u64 = 0;
  let mut x17: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x16, &mut x17, x15, x7, (x9 & (0xffffffff as u64)));
  out1[0] = x10;
  out1[1] = x12;
  out1[2] = x14;
  out1[3] = x16;
}

/*
 * The function fiat_p224_opp negates a field element in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p224_opp(out1: &mut [u64; 4], arg1: &[u64; 4]) -> () {
  let mut x1: u64 = 0;
  let mut x2: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x1, &mut x2, 0x0, (0x0 as u64), (arg1[0]));
  let mut x3: u64 = 0;
  let mut x4: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x3, &mut x4, x2, (0x0 as u64), (arg1[1]));
  let mut x5: u64 = 0;
  let mut x6: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x5, &mut x6, x4, (0x0 as u64), (arg1[2]));
  let mut x7: u64 = 0;
  let mut x8: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x7, &mut x8, x6, (0x0 as u64), (arg1[3]));
  let mut x9: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x9, x8, (0x0 as u64), 0xffffffffffffffff);
  let mut x10: u64 = 0;
  let mut x11: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x10, &mut x11, 0x0, x1, (((x9 & (0x1 as u64)) as fiat_p224_u1) as u64));
  let mut x12: u64 = 0;
  let mut x13: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x12, &mut x13, x11, x3, (x9 & 0xffffffff00000000));
  let mut x14: u64 = 0;
  let mut x15: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x14, &mut x15, x13, x5, (x9 & 0xffffffffffffffff));
  let mut x16: u64 = 0;
  let mut x17: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x16, &mut x17, x15, x7, (x9 & (0xffffffff as u64)));
  out1[0] = x10;
  out1[1] = x12;
  out1[2] = x14;
  out1[3] = x16;
}

/*
 * The function fiat_p224_from_montgomery translates a field element out of the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^4) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p224_from_montgomery(out1: &mut [u64; 4], arg1: &[u64; 4]) -> () {
  let x1: u64 = (arg1[0]);
  let mut x2: u64 = 0;
  let mut x3: u64 = 0;
  fiat_p224_mulx_u64(&mut x2, &mut x3, x1, 0xffffffffffffffff);
  let mut x4: u64 = 0;
  let mut x5: u64 = 0;
  fiat_p224_mulx_u64(&mut x4, &mut x5, x2, 0xffffffff);
  let mut x6: u64 = 0;
  let mut x7: u64 = 0;
  fiat_p224_mulx_u64(&mut x6, &mut x7, x2, 0xffffffffffffffff);
  let mut x8: u64 = 0;
  let mut x9: u64 = 0;
  fiat_p224_mulx_u64(&mut x8, &mut x9, x2, 0xffffffff00000000);
  let mut x10: u64 = 0;
  let mut x11: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x10, &mut x11, 0x0, x9, x6);
  let mut x12: u64 = 0;
  let mut x13: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x12, &mut x13, x11, x7, x4);
  let mut x14: u64 = 0;
  let mut x15: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x14, &mut x15, 0x0, x1, x2);
  let mut x16: u64 = 0;
  let mut x17: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x16, &mut x17, x15, (0x0 as u64), x8);
  let mut x18: u64 = 0;
  let mut x19: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x18, &mut x19, x17, (0x0 as u64), x10);
  let mut x20: u64 = 0;
  let mut x21: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x20, &mut x21, x19, (0x0 as u64), x12);
  let mut x22: u64 = 0;
  let mut x23: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x22, &mut x23, 0x0, x16, (arg1[1]));
  let mut x24: u64 = 0;
  let mut x25: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x24, &mut x25, x23, x18, (0x0 as u64));
  let mut x26: u64 = 0;
  let mut x27: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x26, &mut x27, x25, x20, (0x0 as u64));
  let mut x28: u64 = 0;
  let mut x29: u64 = 0;
  fiat_p224_mulx_u64(&mut x28, &mut x29, x22, 0xffffffffffffffff);
  let mut x30: u64 = 0;
  let mut x31: u64 = 0;
  fiat_p224_mulx_u64(&mut x30, &mut x31, x28, 0xffffffff);
  let mut x32: u64 = 0;
  let mut x33: u64 = 0;
  fiat_p224_mulx_u64(&mut x32, &mut x33, x28, 0xffffffffffffffff);
  let mut x34: u64 = 0;
  let mut x35: u64 = 0;
  fiat_p224_mulx_u64(&mut x34, &mut x35, x28, 0xffffffff00000000);
  let mut x36: u64 = 0;
  let mut x37: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x36, &mut x37, 0x0, x35, x32);
  let mut x38: u64 = 0;
  let mut x39: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x38, &mut x39, x37, x33, x30);
  let mut x40: u64 = 0;
  let mut x41: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x40, &mut x41, 0x0, x22, x28);
  let mut x42: u64 = 0;
  let mut x43: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x42, &mut x43, x41, x24, x34);
  let mut x44: u64 = 0;
  let mut x45: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x44, &mut x45, x43, x26, x36);
  let mut x46: u64 = 0;
  let mut x47: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x46, &mut x47, x13, x5, (0x0 as u64));
  let mut x48: u64 = 0;
  let mut x49: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x48, &mut x49, x21, (0x0 as u64), x46);
  let mut x50: u64 = 0;
  let mut x51: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x50, &mut x51, x27, x48, (0x0 as u64));
  let mut x52: u64 = 0;
  let mut x53: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x52, &mut x53, x45, x50, x38);
  let mut x54: u64 = 0;
  let mut x55: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x54, &mut x55, 0x0, x42, (arg1[2]));
  let mut x56: u64 = 0;
  let mut x57: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x56, &mut x57, x55, x44, (0x0 as u64));
  let mut x58: u64 = 0;
  let mut x59: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x58, &mut x59, x57, x52, (0x0 as u64));
  let mut x60: u64 = 0;
  let mut x61: u64 = 0;
  fiat_p224_mulx_u64(&mut x60, &mut x61, x54, 0xffffffffffffffff);
  let mut x62: u64 = 0;
  let mut x63: u64 = 0;
  fiat_p224_mulx_u64(&mut x62, &mut x63, x60, 0xffffffff);
  let mut x64: u64 = 0;
  let mut x65: u64 = 0;
  fiat_p224_mulx_u64(&mut x64, &mut x65, x60, 0xffffffffffffffff);
  let mut x66: u64 = 0;
  let mut x67: u64 = 0;
  fiat_p224_mulx_u64(&mut x66, &mut x67, x60, 0xffffffff00000000);
  let mut x68: u64 = 0;
  let mut x69: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x68, &mut x69, 0x0, x67, x64);
  let mut x70: u64 = 0;
  let mut x71: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x70, &mut x71, x69, x65, x62);
  let mut x72: u64 = 0;
  let mut x73: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x72, &mut x73, 0x0, x54, x60);
  let mut x74: u64 = 0;
  let mut x75: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x74, &mut x75, x73, x56, x66);
  let mut x76: u64 = 0;
  let mut x77: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x76, &mut x77, x75, x58, x68);
  let mut x78: u64 = 0;
  let mut x79: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x78, &mut x79, x39, x31, (0x0 as u64));
  let mut x80: u64 = 0;
  let mut x81: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x80, &mut x81, x53, (0x0 as u64), x78);
  let mut x82: u64 = 0;
  let mut x83: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x82, &mut x83, x59, x80, (0x0 as u64));
  let mut x84: u64 = 0;
  let mut x85: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x84, &mut x85, x77, x82, x70);
  let mut x86: u64 = 0;
  let mut x87: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x86, &mut x87, 0x0, x74, (arg1[3]));
  let mut x88: u64 = 0;
  let mut x89: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x88, &mut x89, x87, x76, (0x0 as u64));
  let mut x90: u64 = 0;
  let mut x91: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x90, &mut x91, x89, x84, (0x0 as u64));
  let mut x92: u64 = 0;
  let mut x93: u64 = 0;
  fiat_p224_mulx_u64(&mut x92, &mut x93, x86, 0xffffffffffffffff);
  let mut x94: u64 = 0;
  let mut x95: u64 = 0;
  fiat_p224_mulx_u64(&mut x94, &mut x95, x92, 0xffffffff);
  let mut x96: u64 = 0;
  let mut x97: u64 = 0;
  fiat_p224_mulx_u64(&mut x96, &mut x97, x92, 0xffffffffffffffff);
  let mut x98: u64 = 0;
  let mut x99: u64 = 0;
  fiat_p224_mulx_u64(&mut x98, &mut x99, x92, 0xffffffff00000000);
  let mut x100: u64 = 0;
  let mut x101: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x100, &mut x101, 0x0, x99, x96);
  let mut x102: u64 = 0;
  let mut x103: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x102, &mut x103, x101, x97, x94);
  let mut x104: u64 = 0;
  let mut x105: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x104, &mut x105, 0x0, x86, x92);
  let mut x106: u64 = 0;
  let mut x107: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x106, &mut x107, x105, x88, x98);
  let mut x108: u64 = 0;
  let mut x109: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x108, &mut x109, x107, x90, x100);
  let mut x110: u64 = 0;
  let mut x111: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x110, &mut x111, x71, x63, (0x0 as u64));
  let mut x112: u64 = 0;
  let mut x113: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x112, &mut x113, x85, (0x0 as u64), x110);
  let mut x114: u64 = 0;
  let mut x115: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x114, &mut x115, x91, x112, (0x0 as u64));
  let mut x116: u64 = 0;
  let mut x117: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x116, &mut x117, x109, x114, x102);
  let mut x118: u64 = 0;
  let mut x119: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x118, &mut x119, x103, x95, (0x0 as u64));
  let mut x120: u64 = 0;
  let mut x121: fiat_p224_u1 = 0;
  fiat_p224_addcarryx_u64(&mut x120, &mut x121, x117, (0x0 as u64), x118);
  let mut x122: u64 = 0;
  let mut x123: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x122, &mut x123, 0x0, x106, (0x1 as u64));
  let mut x124: u64 = 0;
  let mut x125: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x124, &mut x125, x123, x108, 0xffffffff00000000);
  let mut x126: u64 = 0;
  let mut x127: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x126, &mut x127, x125, x116, 0xffffffffffffffff);
  let mut x128: u64 = 0;
  let mut x129: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x128, &mut x129, x127, x120, (0xffffffff as u64));
  let mut x130: u64 = 0;
  let mut x131: fiat_p224_u1 = 0;
  fiat_p224_subborrowx_u64(&mut x130, &mut x131, x129, (0x0 as u64), (0x0 as u64));
  let mut x132: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x132, x131, x122, x106);
  let mut x133: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x133, x131, x124, x108);
  let mut x134: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x134, x131, x126, x116);
  let mut x135: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x135, x131, x128, x120);
  out1[0] = x132;
  out1[1] = x133;
  out1[2] = x134;
  out1[3] = x135;
}

/*
 * The function fiat_p224_nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
#[inline]
pub fn fiat_p224_nonzero(out1: &mut u64, arg1: &[u64; 4]) -> () {
  let x1: u64 = ((arg1[0]) | ((arg1[1]) | ((arg1[2]) | ((arg1[3]) | (0x0 as u64)))));
  *out1 = x1;
}

/*
 * The function fiat_p224_selectznz is a multi-limb conditional select.
 * Postconditions:
 *   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p224_selectznz(out1: &mut [u64; 4], arg1: fiat_p224_u1, arg2: &[u64; 4], arg3: &[u64; 4]) -> () {
  let mut x1: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x1, arg1, (arg2[0]), (arg3[0]));
  let mut x2: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x2, arg1, (arg2[1]), (arg3[1]));
  let mut x3: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x3, arg1, (arg2[2]), (arg3[2]));
  let mut x4: u64 = 0;
  fiat_p224_cmovznz_u64(&mut x4, arg1, (arg2[3]), (arg3[3]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
}

/*
 * The function fiat_p224_to_bytes serializes a field element in the Montgomery domain to bytes in little-endian order.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..31]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x0], [0x0 ~> 0x0], [0x0 ~> 0x0], [0x0 ~> 0x0]]
 */
#[inline]
pub fn fiat_p224_to_bytes(out1: &mut [u8; 32], arg1: &[u64; 4]) -> () {
  let x1: u64 = (arg1[3]);
  let x2: u64 = (arg1[2]);
  let x3: u64 = (arg1[1]);
  let x4: u64 = (arg1[0]);
  let x5: u64 = (x4 >> 8);
  let x6: u8 = ((x4 & (0xff as u64)) as u8);
  let x7: u64 = (x5 >> 8);
  let x8: u8 = ((x5 & (0xff as u64)) as u8);
  let x9: u64 = (x7 >> 8);
  let x10: u8 = ((x7 & (0xff as u64)) as u8);
  let x11: u64 = (x9 >> 8);
  let x12: u8 = ((x9 & (0xff as u64)) as u8);
  let x13: u64 = (x11 >> 8);
  let x14: u8 = ((x11 & (0xff as u64)) as u8);
  let x15: u64 = (x13 >> 8);
  let x16: u8 = ((x13 & (0xff as u64)) as u8);
  let x17: u8 = ((x15 >> 8) as u8);
  let x18: u8 = ((x15 & (0xff as u64)) as u8);
  let x19: u8 = (x17 & 0xff);
  let x20: u64 = (x3 >> 8);
  let x21: u8 = ((x3 & (0xff as u64)) as u8);
  let x22: u64 = (x20 >> 8);
  let x23: u8 = ((x20 & (0xff as u64)) as u8);
  let x24: u64 = (x22 >> 8);
  let x25: u8 = ((x22 & (0xff as u64)) as u8);
  let x26: u64 = (x24 >> 8);
  let x27: u8 = ((x24 & (0xff as u64)) as u8);
  let x28: u64 = (x26 >> 8);
  let x29: u8 = ((x26 & (0xff as u64)) as u8);
  let x30: u64 = (x28 >> 8);
  let x31: u8 = ((x28 & (0xff as u64)) as u8);
  let x32: u8 = ((x30 >> 8) as u8);
  let x33: u8 = ((x30 & (0xff as u64)) as u8);
  let x34: u8 = (x32 & 0xff);
  let x35: u64 = (x2 >> 8);
  let x36: u8 = ((x2 & (0xff as u64)) as u8);
  let x37: u64 = (x35 >> 8);
  let x38: u8 = ((x35 & (0xff as u64)) as u8);
  let x39: u64 = (x37 >> 8);
  let x40: u8 = ((x37 & (0xff as u64)) as u8);
  let x41: u64 = (x39 >> 8);
  let x42: u8 = ((x39 & (0xff as u64)) as u8);
  let x43: u64 = (x41 >> 8);
  let x44: u8 = ((x41 & (0xff as u64)) as u8);
  let x45: u64 = (x43 >> 8);
  let x46: u8 = ((x43 & (0xff as u64)) as u8);
  let x47: u8 = ((x45 >> 8) as u8);
  let x48: u8 = ((x45 & (0xff as u64)) as u8);
  let x49: u8 = (x47 & 0xff);
  let x50: u64 = (x1 >> 8);
  let x51: u8 = ((x1 & (0xff as u64)) as u8);
  let x52: u64 = (x50 >> 8);
  let x53: u8 = ((x50 & (0xff as u64)) as u8);
  let x54: u8 = ((x52 >> 8) as u8);
  let x55: u8 = ((x52 & (0xff as u64)) as u8);
  let x56: u8 = (x54 & 0xff);
  out1[0] = x6;
  out1[1] = x8;
  out1[2] = x10;
  out1[3] = x12;
  out1[4] = x14;
  out1[5] = x16;
  out1[6] = x18;
  out1[7] = x19;
  out1[8] = x21;
  out1[9] = x23;
  out1[10] = x25;
  out1[11] = x27;
  out1[12] = x29;
  out1[13] = x31;
  out1[14] = x33;
  out1[15] = x34;
  out1[16] = x36;
  out1[17] = x38;
  out1[18] = x40;
  out1[19] = x42;
  out1[20] = x44;
  out1[21] = x46;
  out1[22] = x48;
  out1[23] = x49;
  out1[24] = x51;
  out1[25] = x53;
  out1[26] = x55;
  out1[27] = x56;
  out1[28] = (0x0 as u8);
  out1[29] = (0x0 as u8);
  out1[30] = (0x0 as u8);
  out1[31] = (0x0 as u8);
}

/*
 * The function fiat_p224_from_bytes deserializes a field element in the Montgomery domain from bytes in little-endian order.
 * Preconditions:
 *   0 ≤ bytes_eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x0], [0x0 ~> 0x0], [0x0 ~> 0x0], [0x0 ~> 0x0]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffff]]
 */
#[inline]
pub fn fiat_p224_from_bytes(out1: &mut [u64; 4], arg1: &[u8; 32]) -> () {
  let x1: u64 = (((arg1[27]) as u64) << 24);
  let x2: u64 = (((arg1[26]) as u64) << 16);
  let x3: u64 = (((arg1[25]) as u64) << 8);
  let x4: u8 = (arg1[24]);
  let x5: u64 = (((arg1[23]) as u64) << 56);
  let x6: u64 = (((arg1[22]) as u64) << 48);
  let x7: u64 = (((arg1[21]) as u64) << 40);
  let x8: u64 = (((arg1[20]) as u64) << 32);
  let x9: u64 = (((arg1[19]) as u64) << 24);
  let x10: u64 = (((arg1[18]) as u64) << 16);
  let x11: u64 = (((arg1[17]) as u64) << 8);
  let x12: u8 = (arg1[16]);
  let x13: u64 = (((arg1[15]) as u64) << 56);
  let x14: u64 = (((arg1[14]) as u64) << 48);
  let x15: u64 = (((arg1[13]) as u64) << 40);
  let x16: u64 = (((arg1[12]) as u64) << 32);
  let x17: u64 = (((arg1[11]) as u64) << 24);
  let x18: u64 = (((arg1[10]) as u64) << 16);
  let x19: u64 = (((arg1[9]) as u64) << 8);
  let x20: u8 = (arg1[8]);
  let x21: u64 = (((arg1[7]) as u64) << 56);
  let x22: u64 = (((arg1[6]) as u64) << 48);
  let x23: u64 = (((arg1[5]) as u64) << 40);
  let x24: u64 = (((arg1[4]) as u64) << 32);
  let x25: u64 = (((arg1[3]) as u64) << 24);
  let x26: u64 = (((arg1[2]) as u64) << 16);
  let x27: u64 = (((arg1[1]) as u64) << 8);
  let x28: u8 = (arg1[0]);
  let x29: u64 = ((x28 as u64) + (x27 + (x26 + (x25 + (x24 + (x23 + (x22 + x21)))))));
  let x30: u64 = (x29 & 0xffffffffffffffff);
  let x31: u64 = ((x4 as u64) + (x3 + (x2 + x1)));
  let x32: u64 = ((x12 as u64) + (x11 + (x10 + (x9 + (x8 + (x7 + (x6 + x5)))))));
  let x33: u64 = ((x20 as u64) + (x19 + (x18 + (x17 + (x16 + (x15 + (x14 + x13)))))));
  let x34: u64 = (x33 & 0xffffffffffffffff);
  let x35: u64 = (x32 & 0xffffffffffffffff);
  out1[0] = x30;
  out1[1] = x34;
  out1[2] = x35;
  out1[3] = x31;
}

