/* Autogenerated: src/ExtractionOCaml/word_by_word_montgomery --lang=Rust p256 '2^256 - 2^224 + 2^192 + 2^96 - 1' 64 */
/* curve description: p256 */
/* requested operations: (all) */
/* m = 0xffffffff00000001000000000000000000000000ffffffffffffffffffffffff (from "2^256 - 2^224 + 2^192 + 2^96 - 1") */
/* machine_wordsize = 64 (from "64") */
/*                                                                    */
/* NOTE: In addition to the bounds specified above each function, all */
/*   functions synthesized for this Montgomery arithmetic require the */
/*   input to be strictly less than the prime modulus (m), and also   */
/*   require the input to be in the unique saturated representation.  */
/*   All functions also ensure that these two properties are true of  */
/*   return values.                                                   */

#![allow(unused_parens)]
#[allow(non_camel_case_types)]

pub type fiat_p256_u1 = u8;
pub type fiat_p256_i1 = i8;
pub type fiat_p256_u2 = u8;
pub type fiat_p256_i2 = i8;
pub type fiat_p256_u128 = u128;
pub type fiat_p256_i128 = i128;


/*
 * The function fiat_p256_addcarryx_u64 is an addition with carry.
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^64
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
#[inline]
pub fn fiat_p256_addcarryx_u64(out1: &mut u64, out2: &mut fiat_p256_u1, arg1: fiat_p256_u1, arg2: u64, arg3: u64) -> () {
  let x1: fiat_p256_u128 = (((arg1 as fiat_p256_u128) + (arg2 as fiat_p256_u128)) + (arg3 as fiat_p256_u128));
  let x2: u64 = ((x1 & (0xffffffffffffffff as fiat_p256_u128)) as u64);
  let x3: fiat_p256_u1 = ((x1 >> 64) as fiat_p256_u1);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p256_subborrowx_u64 is a subtraction with borrow.
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^64
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
#[inline]
pub fn fiat_p256_subborrowx_u64(out1: &mut u64, out2: &mut fiat_p256_u1, arg1: fiat_p256_u1, arg2: u64, arg3: u64) -> () {
  let x1: fiat_p256_i128 = (((arg2 as fiat_p256_i128) - (arg1 as fiat_p256_i128)) - (arg3 as fiat_p256_i128));
  let x2: fiat_p256_i1 = ((x1 >> 64) as fiat_p256_i1);
  let x3: u64 = ((x1 & (0xffffffffffffffff as fiat_p256_i128)) as u64);
  *out1 = x3;
  *out2 = (((0x0 as fiat_p256_i2) - (x2 as fiat_p256_i2)) as fiat_p256_u1);
}

/*
 * The function fiat_p256_mulx_u64 is a multiplication, returning the full double-width result.
 * Postconditions:
 *   out1 = (arg1 * arg2) mod 2^64
 *   out2 = ⌊arg1 * arg2 / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffffffffffff]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0xffffffffffffffff]
 */
#[inline]
pub fn fiat_p256_mulx_u64(out1: &mut u64, out2: &mut u64, arg1: u64, arg2: u64) -> () {
  let x1: fiat_p256_u128 = ((arg1 as fiat_p256_u128) * (arg2 as fiat_p256_u128));
  let x2: u64 = ((x1 & (0xffffffffffffffff as fiat_p256_u128)) as u64);
  let x3: u64 = ((x1 >> 64) as u64);
  *out1 = x2;
  *out2 = x3;
}

/*
 * The function fiat_p256_cmovznz_u64 is a single-word conditional move.
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
#[inline]
pub fn fiat_p256_cmovznz_u64(out1: &mut u64, arg1: fiat_p256_u1, arg2: u64, arg3: u64) -> () {
  let x1: fiat_p256_u1 = (!(!arg1));
  let x2: u64 = ((((((0x0 as fiat_p256_i2) - (x1 as fiat_p256_i2)) as fiat_p256_i1) as fiat_p256_i128) & (0xffffffffffffffff as fiat_p256_i128)) as u64);
  let x3: u64 = ((x2 & arg3) | ((!x2) & arg2));
  *out1 = x3;
}

/*
 * The function fiat_p256_mul multiplies two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p256_mul(out1: &mut [u64; 4], arg1: &[u64; 4], arg2: &[u64; 4]) -> () {
  let x1: u64 = (arg1[1]);
  let x2: u64 = (arg1[2]);
  let x3: u64 = (arg1[3]);
  let x4: u64 = (arg1[0]);
  let mut x5: u64 = 0;
  let mut x6: u64 = 0;
  fiat_p256_mulx_u64(&mut x5, &mut x6, x4, (arg2[3]));
  let mut x7: u64 = 0;
  let mut x8: u64 = 0;
  fiat_p256_mulx_u64(&mut x7, &mut x8, x4, (arg2[2]));
  let mut x9: u64 = 0;
  let mut x10: u64 = 0;
  fiat_p256_mulx_u64(&mut x9, &mut x10, x4, (arg2[1]));
  let mut x11: u64 = 0;
  let mut x12: u64 = 0;
  fiat_p256_mulx_u64(&mut x11, &mut x12, x4, (arg2[0]));
  let mut x13: u64 = 0;
  let mut x14: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x13, &mut x14, 0x0, x12, x9);
  let mut x15: u64 = 0;
  let mut x16: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x15, &mut x16, x14, x10, x7);
  let mut x17: u64 = 0;
  let mut x18: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x17, &mut x18, x16, x8, x5);
  let mut x19: u64 = 0;
  let mut x20: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x19, &mut x20, x18, x6, (0x0 as u64));
  let mut x21: u64 = 0;
  let mut x22: u64 = 0;
  fiat_p256_mulx_u64(&mut x21, &mut x22, x11, 0xffffffff00000001);
  let mut x23: u64 = 0;
  let mut x24: u64 = 0;
  fiat_p256_mulx_u64(&mut x23, &mut x24, x11, 0xffffffff);
  let mut x25: u64 = 0;
  let mut x26: u64 = 0;
  fiat_p256_mulx_u64(&mut x25, &mut x26, x11, 0xffffffffffffffff);
  let mut x27: u64 = 0;
  let mut x28: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x27, &mut x28, 0x0, x26, x23);
  let mut x29: u64 = 0;
  let mut x30: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x29, &mut x30, x28, x24, (0x0 as u64));
  let mut x31: u64 = 0;
  let mut x32: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x31, &mut x32, 0x0, x11, x25);
  let mut x33: u64 = 0;
  let mut x34: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x33, &mut x34, x32, x13, x27);
  let mut x35: u64 = 0;
  let mut x36: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x35, &mut x36, x34, x15, x29);
  let mut x37: u64 = 0;
  let mut x38: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x37, &mut x38, x36, x17, x21);
  let mut x39: u64 = 0;
  let mut x40: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x39, &mut x40, x38, x19, x22);
  let mut x41: u64 = 0;
  let mut x42: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x41, &mut x42, x40, (0x0 as u64), (0x0 as u64));
  let mut x43: u64 = 0;
  let mut x44: u64 = 0;
  fiat_p256_mulx_u64(&mut x43, &mut x44, x1, (arg2[3]));
  let mut x45: u64 = 0;
  let mut x46: u64 = 0;
  fiat_p256_mulx_u64(&mut x45, &mut x46, x1, (arg2[2]));
  let mut x47: u64 = 0;
  let mut x48: u64 = 0;
  fiat_p256_mulx_u64(&mut x47, &mut x48, x1, (arg2[1]));
  let mut x49: u64 = 0;
  let mut x50: u64 = 0;
  fiat_p256_mulx_u64(&mut x49, &mut x50, x1, (arg2[0]));
  let mut x51: u64 = 0;
  let mut x52: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x51, &mut x52, 0x0, x50, x47);
  let mut x53: u64 = 0;
  let mut x54: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x53, &mut x54, x52, x48, x45);
  let mut x55: u64 = 0;
  let mut x56: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x55, &mut x56, x54, x46, x43);
  let mut x57: u64 = 0;
  let mut x58: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x57, &mut x58, x56, x44, (0x0 as u64));
  let mut x59: u64 = 0;
  let mut x60: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x59, &mut x60, 0x0, x33, x49);
  let mut x61: u64 = 0;
  let mut x62: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x61, &mut x62, x60, x35, x51);
  let mut x63: u64 = 0;
  let mut x64: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x63, &mut x64, x62, x37, x53);
  let mut x65: u64 = 0;
  let mut x66: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x65, &mut x66, x64, x39, x55);
  let mut x67: u64 = 0;
  let mut x68: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x67, &mut x68, x66, ((x41 as fiat_p256_u1) as u64), x57);
  let mut x69: u64 = 0;
  let mut x70: u64 = 0;
  fiat_p256_mulx_u64(&mut x69, &mut x70, x59, 0xffffffff00000001);
  let mut x71: u64 = 0;
  let mut x72: u64 = 0;
  fiat_p256_mulx_u64(&mut x71, &mut x72, x59, 0xffffffff);
  let mut x73: u64 = 0;
  let mut x74: u64 = 0;
  fiat_p256_mulx_u64(&mut x73, &mut x74, x59, 0xffffffffffffffff);
  let mut x75: u64 = 0;
  let mut x76: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x75, &mut x76, 0x0, x74, x71);
  let mut x77: u64 = 0;
  let mut x78: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x77, &mut x78, x76, x72, (0x0 as u64));
  let mut x79: u64 = 0;
  let mut x80: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x79, &mut x80, 0x0, x59, x73);
  let mut x81: u64 = 0;
  let mut x82: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x81, &mut x82, x80, x61, x75);
  let mut x83: u64 = 0;
  let mut x84: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x83, &mut x84, x82, x63, x77);
  let mut x85: u64 = 0;
  let mut x86: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x85, &mut x86, x84, x65, x69);
  let mut x87: u64 = 0;
  let mut x88: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x87, &mut x88, x86, x67, x70);
  let mut x89: u64 = 0;
  let mut x90: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x89, &mut x90, x88, (x68 as u64), (0x0 as u64));
  let mut x91: u64 = 0;
  let mut x92: u64 = 0;
  fiat_p256_mulx_u64(&mut x91, &mut x92, x2, (arg2[3]));
  let mut x93: u64 = 0;
  let mut x94: u64 = 0;
  fiat_p256_mulx_u64(&mut x93, &mut x94, x2, (arg2[2]));
  let mut x95: u64 = 0;
  let mut x96: u64 = 0;
  fiat_p256_mulx_u64(&mut x95, &mut x96, x2, (arg2[1]));
  let mut x97: u64 = 0;
  let mut x98: u64 = 0;
  fiat_p256_mulx_u64(&mut x97, &mut x98, x2, (arg2[0]));
  let mut x99: u64 = 0;
  let mut x100: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x99, &mut x100, 0x0, x98, x95);
  let mut x101: u64 = 0;
  let mut x102: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x101, &mut x102, x100, x96, x93);
  let mut x103: u64 = 0;
  let mut x104: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x103, &mut x104, x102, x94, x91);
  let mut x105: u64 = 0;
  let mut x106: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x105, &mut x106, x104, x92, (0x0 as u64));
  let mut x107: u64 = 0;
  let mut x108: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x107, &mut x108, 0x0, x81, x97);
  let mut x109: u64 = 0;
  let mut x110: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x109, &mut x110, x108, x83, x99);
  let mut x111: u64 = 0;
  let mut x112: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x111, &mut x112, x110, x85, x101);
  let mut x113: u64 = 0;
  let mut x114: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x113, &mut x114, x112, x87, x103);
  let mut x115: u64 = 0;
  let mut x116: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x115, &mut x116, x114, x89, x105);
  let mut x117: u64 = 0;
  let mut x118: u64 = 0;
  fiat_p256_mulx_u64(&mut x117, &mut x118, x107, 0xffffffff00000001);
  let mut x119: u64 = 0;
  let mut x120: u64 = 0;
  fiat_p256_mulx_u64(&mut x119, &mut x120, x107, 0xffffffff);
  let mut x121: u64 = 0;
  let mut x122: u64 = 0;
  fiat_p256_mulx_u64(&mut x121, &mut x122, x107, 0xffffffffffffffff);
  let mut x123: u64 = 0;
  let mut x124: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x123, &mut x124, 0x0, x122, x119);
  let mut x125: u64 = 0;
  let mut x126: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x125, &mut x126, x124, x120, (0x0 as u64));
  let mut x127: u64 = 0;
  let mut x128: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x127, &mut x128, 0x0, x107, x121);
  let mut x129: u64 = 0;
  let mut x130: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x129, &mut x130, x128, x109, x123);
  let mut x131: u64 = 0;
  let mut x132: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x131, &mut x132, x130, x111, x125);
  let mut x133: u64 = 0;
  let mut x134: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x133, &mut x134, x132, x113, x117);
  let mut x135: u64 = 0;
  let mut x136: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x135, &mut x136, x134, x115, x118);
  let mut x137: u64 = 0;
  let mut x138: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x137, &mut x138, x136, (x116 as u64), (0x0 as u64));
  let mut x139: u64 = 0;
  let mut x140: u64 = 0;
  fiat_p256_mulx_u64(&mut x139, &mut x140, x3, (arg2[3]));
  let mut x141: u64 = 0;
  let mut x142: u64 = 0;
  fiat_p256_mulx_u64(&mut x141, &mut x142, x3, (arg2[2]));
  let mut x143: u64 = 0;
  let mut x144: u64 = 0;
  fiat_p256_mulx_u64(&mut x143, &mut x144, x3, (arg2[1]));
  let mut x145: u64 = 0;
  let mut x146: u64 = 0;
  fiat_p256_mulx_u64(&mut x145, &mut x146, x3, (arg2[0]));
  let mut x147: u64 = 0;
  let mut x148: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x147, &mut x148, 0x0, x146, x143);
  let mut x149: u64 = 0;
  let mut x150: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x149, &mut x150, x148, x144, x141);
  let mut x151: u64 = 0;
  let mut x152: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x151, &mut x152, x150, x142, x139);
  let mut x153: u64 = 0;
  let mut x154: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x153, &mut x154, x152, x140, (0x0 as u64));
  let mut x155: u64 = 0;
  let mut x156: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x155, &mut x156, 0x0, x129, x145);
  let mut x157: u64 = 0;
  let mut x158: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x157, &mut x158, x156, x131, x147);
  let mut x159: u64 = 0;
  let mut x160: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x159, &mut x160, x158, x133, x149);
  let mut x161: u64 = 0;
  let mut x162: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x161, &mut x162, x160, x135, x151);
  let mut x163: u64 = 0;
  let mut x164: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x163, &mut x164, x162, x137, x153);
  let mut x165: u64 = 0;
  let mut x166: u64 = 0;
  fiat_p256_mulx_u64(&mut x165, &mut x166, x155, 0xffffffff00000001);
  let mut x167: u64 = 0;
  let mut x168: u64 = 0;
  fiat_p256_mulx_u64(&mut x167, &mut x168, x155, 0xffffffff);
  let mut x169: u64 = 0;
  let mut x170: u64 = 0;
  fiat_p256_mulx_u64(&mut x169, &mut x170, x155, 0xffffffffffffffff);
  let mut x171: u64 = 0;
  let mut x172: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x171, &mut x172, 0x0, x170, x167);
  let mut x173: u64 = 0;
  let mut x174: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x173, &mut x174, x172, x168, (0x0 as u64));
  let mut x175: u64 = 0;
  let mut x176: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x175, &mut x176, 0x0, x155, x169);
  let mut x177: u64 = 0;
  let mut x178: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x177, &mut x178, x176, x157, x171);
  let mut x179: u64 = 0;
  let mut x180: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x179, &mut x180, x178, x159, x173);
  let mut x181: u64 = 0;
  let mut x182: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x181, &mut x182, x180, x161, x165);
  let mut x183: u64 = 0;
  let mut x184: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x183, &mut x184, x182, x163, x166);
  let mut x185: u64 = 0;
  let mut x186: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x185, &mut x186, x184, (x164 as u64), (0x0 as u64));
  let mut x187: u64 = 0;
  let mut x188: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x187, &mut x188, 0x0, x177, 0xffffffffffffffff);
  let mut x189: u64 = 0;
  let mut x190: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x189, &mut x190, x188, x179, (0xffffffff as u64));
  let mut x191: u64 = 0;
  let mut x192: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x191, &mut x192, x190, x181, (0x0 as u64));
  let mut x193: u64 = 0;
  let mut x194: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x193, &mut x194, x192, x183, 0xffffffff00000001);
  let mut x195: u64 = 0;
  let mut x196: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x195, &mut x196, x194, x185, (0x0 as u64));
  let mut x197: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x197, x196, x187, x177);
  let mut x198: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x198, x196, x189, x179);
  let mut x199: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x199, x196, x191, x181);
  let mut x200: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x200, x196, x193, x183);
  out1[0] = x197;
  out1[1] = x198;
  out1[2] = x199;
  out1[3] = x200;
}

/*
 * The function fiat_p256_square squares a field element in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p256_square(out1: &mut [u64; 4], arg1: &[u64; 4]) -> () {
  let x1: u64 = (arg1[1]);
  let x2: u64 = (arg1[2]);
  let x3: u64 = (arg1[3]);
  let x4: u64 = (arg1[0]);
  let mut x5: u64 = 0;
  let mut x6: u64 = 0;
  fiat_p256_mulx_u64(&mut x5, &mut x6, x4, (arg1[3]));
  let mut x7: u64 = 0;
  let mut x8: u64 = 0;
  fiat_p256_mulx_u64(&mut x7, &mut x8, x4, (arg1[2]));
  let mut x9: u64 = 0;
  let mut x10: u64 = 0;
  fiat_p256_mulx_u64(&mut x9, &mut x10, x4, (arg1[1]));
  let mut x11: u64 = 0;
  let mut x12: u64 = 0;
  fiat_p256_mulx_u64(&mut x11, &mut x12, x4, (arg1[0]));
  let mut x13: u64 = 0;
  let mut x14: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x13, &mut x14, 0x0, x12, x9);
  let mut x15: u64 = 0;
  let mut x16: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x15, &mut x16, x14, x10, x7);
  let mut x17: u64 = 0;
  let mut x18: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x17, &mut x18, x16, x8, x5);
  let mut x19: u64 = 0;
  let mut x20: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x19, &mut x20, x18, x6, (0x0 as u64));
  let mut x21: u64 = 0;
  let mut x22: u64 = 0;
  fiat_p256_mulx_u64(&mut x21, &mut x22, x11, 0xffffffff00000001);
  let mut x23: u64 = 0;
  let mut x24: u64 = 0;
  fiat_p256_mulx_u64(&mut x23, &mut x24, x11, 0xffffffff);
  let mut x25: u64 = 0;
  let mut x26: u64 = 0;
  fiat_p256_mulx_u64(&mut x25, &mut x26, x11, 0xffffffffffffffff);
  let mut x27: u64 = 0;
  let mut x28: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x27, &mut x28, 0x0, x26, x23);
  let mut x29: u64 = 0;
  let mut x30: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x29, &mut x30, x28, x24, (0x0 as u64));
  let mut x31: u64 = 0;
  let mut x32: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x31, &mut x32, 0x0, x11, x25);
  let mut x33: u64 = 0;
  let mut x34: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x33, &mut x34, x32, x13, x27);
  let mut x35: u64 = 0;
  let mut x36: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x35, &mut x36, x34, x15, x29);
  let mut x37: u64 = 0;
  let mut x38: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x37, &mut x38, x36, x17, x21);
  let mut x39: u64 = 0;
  let mut x40: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x39, &mut x40, x38, x19, x22);
  let mut x41: u64 = 0;
  let mut x42: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x41, &mut x42, x40, (0x0 as u64), (0x0 as u64));
  let mut x43: u64 = 0;
  let mut x44: u64 = 0;
  fiat_p256_mulx_u64(&mut x43, &mut x44, x1, (arg1[3]));
  let mut x45: u64 = 0;
  let mut x46: u64 = 0;
  fiat_p256_mulx_u64(&mut x45, &mut x46, x1, (arg1[2]));
  let mut x47: u64 = 0;
  let mut x48: u64 = 0;
  fiat_p256_mulx_u64(&mut x47, &mut x48, x1, (arg1[1]));
  let mut x49: u64 = 0;
  let mut x50: u64 = 0;
  fiat_p256_mulx_u64(&mut x49, &mut x50, x1, (arg1[0]));
  let mut x51: u64 = 0;
  let mut x52: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x51, &mut x52, 0x0, x50, x47);
  let mut x53: u64 = 0;
  let mut x54: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x53, &mut x54, x52, x48, x45);
  let mut x55: u64 = 0;
  let mut x56: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x55, &mut x56, x54, x46, x43);
  let mut x57: u64 = 0;
  let mut x58: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x57, &mut x58, x56, x44, (0x0 as u64));
  let mut x59: u64 = 0;
  let mut x60: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x59, &mut x60, 0x0, x33, x49);
  let mut x61: u64 = 0;
  let mut x62: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x61, &mut x62, x60, x35, x51);
  let mut x63: u64 = 0;
  let mut x64: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x63, &mut x64, x62, x37, x53);
  let mut x65: u64 = 0;
  let mut x66: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x65, &mut x66, x64, x39, x55);
  let mut x67: u64 = 0;
  let mut x68: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x67, &mut x68, x66, ((x41 as fiat_p256_u1) as u64), x57);
  let mut x69: u64 = 0;
  let mut x70: u64 = 0;
  fiat_p256_mulx_u64(&mut x69, &mut x70, x59, 0xffffffff00000001);
  let mut x71: u64 = 0;
  let mut x72: u64 = 0;
  fiat_p256_mulx_u64(&mut x71, &mut x72, x59, 0xffffffff);
  let mut x73: u64 = 0;
  let mut x74: u64 = 0;
  fiat_p256_mulx_u64(&mut x73, &mut x74, x59, 0xffffffffffffffff);
  let mut x75: u64 = 0;
  let mut x76: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x75, &mut x76, 0x0, x74, x71);
  let mut x77: u64 = 0;
  let mut x78: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x77, &mut x78, x76, x72, (0x0 as u64));
  let mut x79: u64 = 0;
  let mut x80: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x79, &mut x80, 0x0, x59, x73);
  let mut x81: u64 = 0;
  let mut x82: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x81, &mut x82, x80, x61, x75);
  let mut x83: u64 = 0;
  let mut x84: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x83, &mut x84, x82, x63, x77);
  let mut x85: u64 = 0;
  let mut x86: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x85, &mut x86, x84, x65, x69);
  let mut x87: u64 = 0;
  let mut x88: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x87, &mut x88, x86, x67, x70);
  let mut x89: u64 = 0;
  let mut x90: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x89, &mut x90, x88, (x68 as u64), (0x0 as u64));
  let mut x91: u64 = 0;
  let mut x92: u64 = 0;
  fiat_p256_mulx_u64(&mut x91, &mut x92, x2, (arg1[3]));
  let mut x93: u64 = 0;
  let mut x94: u64 = 0;
  fiat_p256_mulx_u64(&mut x93, &mut x94, x2, (arg1[2]));
  let mut x95: u64 = 0;
  let mut x96: u64 = 0;
  fiat_p256_mulx_u64(&mut x95, &mut x96, x2, (arg1[1]));
  let mut x97: u64 = 0;
  let mut x98: u64 = 0;
  fiat_p256_mulx_u64(&mut x97, &mut x98, x2, (arg1[0]));
  let mut x99: u64 = 0;
  let mut x100: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x99, &mut x100, 0x0, x98, x95);
  let mut x101: u64 = 0;
  let mut x102: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x101, &mut x102, x100, x96, x93);
  let mut x103: u64 = 0;
  let mut x104: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x103, &mut x104, x102, x94, x91);
  let mut x105: u64 = 0;
  let mut x106: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x105, &mut x106, x104, x92, (0x0 as u64));
  let mut x107: u64 = 0;
  let mut x108: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x107, &mut x108, 0x0, x81, x97);
  let mut x109: u64 = 0;
  let mut x110: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x109, &mut x110, x108, x83, x99);
  let mut x111: u64 = 0;
  let mut x112: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x111, &mut x112, x110, x85, x101);
  let mut x113: u64 = 0;
  let mut x114: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x113, &mut x114, x112, x87, x103);
  let mut x115: u64 = 0;
  let mut x116: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x115, &mut x116, x114, x89, x105);
  let mut x117: u64 = 0;
  let mut x118: u64 = 0;
  fiat_p256_mulx_u64(&mut x117, &mut x118, x107, 0xffffffff00000001);
  let mut x119: u64 = 0;
  let mut x120: u64 = 0;
  fiat_p256_mulx_u64(&mut x119, &mut x120, x107, 0xffffffff);
  let mut x121: u64 = 0;
  let mut x122: u64 = 0;
  fiat_p256_mulx_u64(&mut x121, &mut x122, x107, 0xffffffffffffffff);
  let mut x123: u64 = 0;
  let mut x124: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x123, &mut x124, 0x0, x122, x119);
  let mut x125: u64 = 0;
  let mut x126: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x125, &mut x126, x124, x120, (0x0 as u64));
  let mut x127: u64 = 0;
  let mut x128: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x127, &mut x128, 0x0, x107, x121);
  let mut x129: u64 = 0;
  let mut x130: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x129, &mut x130, x128, x109, x123);
  let mut x131: u64 = 0;
  let mut x132: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x131, &mut x132, x130, x111, x125);
  let mut x133: u64 = 0;
  let mut x134: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x133, &mut x134, x132, x113, x117);
  let mut x135: u64 = 0;
  let mut x136: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x135, &mut x136, x134, x115, x118);
  let mut x137: u64 = 0;
  let mut x138: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x137, &mut x138, x136, (x116 as u64), (0x0 as u64));
  let mut x139: u64 = 0;
  let mut x140: u64 = 0;
  fiat_p256_mulx_u64(&mut x139, &mut x140, x3, (arg1[3]));
  let mut x141: u64 = 0;
  let mut x142: u64 = 0;
  fiat_p256_mulx_u64(&mut x141, &mut x142, x3, (arg1[2]));
  let mut x143: u64 = 0;
  let mut x144: u64 = 0;
  fiat_p256_mulx_u64(&mut x143, &mut x144, x3, (arg1[1]));
  let mut x145: u64 = 0;
  let mut x146: u64 = 0;
  fiat_p256_mulx_u64(&mut x145, &mut x146, x3, (arg1[0]));
  let mut x147: u64 = 0;
  let mut x148: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x147, &mut x148, 0x0, x146, x143);
  let mut x149: u64 = 0;
  let mut x150: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x149, &mut x150, x148, x144, x141);
  let mut x151: u64 = 0;
  let mut x152: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x151, &mut x152, x150, x142, x139);
  let mut x153: u64 = 0;
  let mut x154: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x153, &mut x154, x152, x140, (0x0 as u64));
  let mut x155: u64 = 0;
  let mut x156: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x155, &mut x156, 0x0, x129, x145);
  let mut x157: u64 = 0;
  let mut x158: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x157, &mut x158, x156, x131, x147);
  let mut x159: u64 = 0;
  let mut x160: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x159, &mut x160, x158, x133, x149);
  let mut x161: u64 = 0;
  let mut x162: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x161, &mut x162, x160, x135, x151);
  let mut x163: u64 = 0;
  let mut x164: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x163, &mut x164, x162, x137, x153);
  let mut x165: u64 = 0;
  let mut x166: u64 = 0;
  fiat_p256_mulx_u64(&mut x165, &mut x166, x155, 0xffffffff00000001);
  let mut x167: u64 = 0;
  let mut x168: u64 = 0;
  fiat_p256_mulx_u64(&mut x167, &mut x168, x155, 0xffffffff);
  let mut x169: u64 = 0;
  let mut x170: u64 = 0;
  fiat_p256_mulx_u64(&mut x169, &mut x170, x155, 0xffffffffffffffff);
  let mut x171: u64 = 0;
  let mut x172: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x171, &mut x172, 0x0, x170, x167);
  let mut x173: u64 = 0;
  let mut x174: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x173, &mut x174, x172, x168, (0x0 as u64));
  let mut x175: u64 = 0;
  let mut x176: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x175, &mut x176, 0x0, x155, x169);
  let mut x177: u64 = 0;
  let mut x178: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x177, &mut x178, x176, x157, x171);
  let mut x179: u64 = 0;
  let mut x180: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x179, &mut x180, x178, x159, x173);
  let mut x181: u64 = 0;
  let mut x182: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x181, &mut x182, x180, x161, x165);
  let mut x183: u64 = 0;
  let mut x184: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x183, &mut x184, x182, x163, x166);
  let mut x185: u64 = 0;
  let mut x186: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x185, &mut x186, x184, (x164 as u64), (0x0 as u64));
  let mut x187: u64 = 0;
  let mut x188: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x187, &mut x188, 0x0, x177, 0xffffffffffffffff);
  let mut x189: u64 = 0;
  let mut x190: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x189, &mut x190, x188, x179, (0xffffffff as u64));
  let mut x191: u64 = 0;
  let mut x192: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x191, &mut x192, x190, x181, (0x0 as u64));
  let mut x193: u64 = 0;
  let mut x194: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x193, &mut x194, x192, x183, 0xffffffff00000001);
  let mut x195: u64 = 0;
  let mut x196: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x195, &mut x196, x194, x185, (0x0 as u64));
  let mut x197: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x197, x196, x187, x177);
  let mut x198: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x198, x196, x189, x179);
  let mut x199: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x199, x196, x191, x181);
  let mut x200: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x200, x196, x193, x183);
  out1[0] = x197;
  out1[1] = x198;
  out1[2] = x199;
  out1[3] = x200;
}

/*
 * The function fiat_p256_add adds two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p256_add(out1: &mut [u64; 4], arg1: &[u64; 4], arg2: &[u64; 4]) -> () {
  let mut x1: u64 = 0;
  let mut x2: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x1, &mut x2, 0x0, (arg1[0]), (arg2[0]));
  let mut x3: u64 = 0;
  let mut x4: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x3, &mut x4, x2, (arg1[1]), (arg2[1]));
  let mut x5: u64 = 0;
  let mut x6: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x5, &mut x6, x4, (arg1[2]), (arg2[2]));
  let mut x7: u64 = 0;
  let mut x8: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x7, &mut x8, x6, (arg1[3]), (arg2[3]));
  let mut x9: u64 = 0;
  let mut x10: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x9, &mut x10, 0x0, x1, 0xffffffffffffffff);
  let mut x11: u64 = 0;
  let mut x12: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x11, &mut x12, x10, x3, (0xffffffff as u64));
  let mut x13: u64 = 0;
  let mut x14: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x13, &mut x14, x12, x5, (0x0 as u64));
  let mut x15: u64 = 0;
  let mut x16: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x15, &mut x16, x14, x7, 0xffffffff00000001);
  let mut x17: u64 = 0;
  let mut x18: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x17, &mut x18, x16, (x8 as u64), (0x0 as u64));
  let mut x19: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x19, x18, x9, x1);
  let mut x20: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x20, x18, x11, x3);
  let mut x21: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x21, x18, x13, x5);
  let mut x22: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x22, x18, x15, x7);
  out1[0] = x19;
  out1[1] = x20;
  out1[2] = x21;
  out1[3] = x22;
}

/*
 * The function fiat_p256_sub subtracts two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p256_sub(out1: &mut [u64; 4], arg1: &[u64; 4], arg2: &[u64; 4]) -> () {
  let mut x1: u64 = 0;
  let mut x2: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x1, &mut x2, 0x0, (arg1[0]), (arg2[0]));
  let mut x3: u64 = 0;
  let mut x4: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x3, &mut x4, x2, (arg1[1]), (arg2[1]));
  let mut x5: u64 = 0;
  let mut x6: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x5, &mut x6, x4, (arg1[2]), (arg2[2]));
  let mut x7: u64 = 0;
  let mut x8: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x7, &mut x8, x6, (arg1[3]), (arg2[3]));
  let mut x9: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x9, x8, (0x0 as u64), 0xffffffffffffffff);
  let mut x10: u64 = 0;
  let mut x11: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x10, &mut x11, 0x0, x1, (x9 & 0xffffffffffffffff));
  let mut x12: u64 = 0;
  let mut x13: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x12, &mut x13, x11, x3, (x9 & (0xffffffff as u64)));
  let mut x14: u64 = 0;
  let mut x15: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x14, &mut x15, x13, x5, (0x0 as u64));
  let mut x16: u64 = 0;
  let mut x17: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x16, &mut x17, x15, x7, (x9 & 0xffffffff00000001));
  out1[0] = x10;
  out1[1] = x12;
  out1[2] = x14;
  out1[3] = x16;
}

/*
 * The function fiat_p256_opp negates a field element in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p256_opp(out1: &mut [u64; 4], arg1: &[u64; 4]) -> () {
  let mut x1: u64 = 0;
  let mut x2: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x1, &mut x2, 0x0, (0x0 as u64), (arg1[0]));
  let mut x3: u64 = 0;
  let mut x4: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x3, &mut x4, x2, (0x0 as u64), (arg1[1]));
  let mut x5: u64 = 0;
  let mut x6: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x5, &mut x6, x4, (0x0 as u64), (arg1[2]));
  let mut x7: u64 = 0;
  let mut x8: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x7, &mut x8, x6, (0x0 as u64), (arg1[3]));
  let mut x9: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x9, x8, (0x0 as u64), 0xffffffffffffffff);
  let mut x10: u64 = 0;
  let mut x11: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x10, &mut x11, 0x0, x1, (x9 & 0xffffffffffffffff));
  let mut x12: u64 = 0;
  let mut x13: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x12, &mut x13, x11, x3, (x9 & (0xffffffff as u64)));
  let mut x14: u64 = 0;
  let mut x15: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x14, &mut x15, x13, x5, (0x0 as u64));
  let mut x16: u64 = 0;
  let mut x17: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x16, &mut x17, x15, x7, (x9 & 0xffffffff00000001));
  out1[0] = x10;
  out1[1] = x12;
  out1[2] = x14;
  out1[3] = x16;
}

/*
 * The function fiat_p256_from_montgomery translates a field element out of the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^4) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p256_from_montgomery(out1: &mut [u64; 4], arg1: &[u64; 4]) -> () {
  let x1: u64 = (arg1[0]);
  let mut x2: u64 = 0;
  let mut x3: u64 = 0;
  fiat_p256_mulx_u64(&mut x2, &mut x3, x1, 0xffffffff00000001);
  let mut x4: u64 = 0;
  let mut x5: u64 = 0;
  fiat_p256_mulx_u64(&mut x4, &mut x5, x1, 0xffffffff);
  let mut x6: u64 = 0;
  let mut x7: u64 = 0;
  fiat_p256_mulx_u64(&mut x6, &mut x7, x1, 0xffffffffffffffff);
  let mut x8: u64 = 0;
  let mut x9: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x8, &mut x9, 0x0, x7, x4);
  let mut x10: u64 = 0;
  let mut x11: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x10, &mut x11, 0x0, x1, x6);
  let mut x12: u64 = 0;
  let mut x13: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x12, &mut x13, x11, (0x0 as u64), x8);
  let mut x14: u64 = 0;
  let mut x15: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x14, &mut x15, 0x0, x12, (arg1[1]));
  let mut x16: u64 = 0;
  let mut x17: u64 = 0;
  fiat_p256_mulx_u64(&mut x16, &mut x17, x14, 0xffffffff00000001);
  let mut x18: u64 = 0;
  let mut x19: u64 = 0;
  fiat_p256_mulx_u64(&mut x18, &mut x19, x14, 0xffffffff);
  let mut x20: u64 = 0;
  let mut x21: u64 = 0;
  fiat_p256_mulx_u64(&mut x20, &mut x21, x14, 0xffffffffffffffff);
  let mut x22: u64 = 0;
  let mut x23: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x22, &mut x23, 0x0, x21, x18);
  let mut x24: u64 = 0;
  let mut x25: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x24, &mut x25, x9, x5, (0x0 as u64));
  let mut x26: u64 = 0;
  let mut x27: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x26, &mut x27, x13, (0x0 as u64), x24);
  let mut x28: u64 = 0;
  let mut x29: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x28, &mut x29, x15, x26, (0x0 as u64));
  let mut x30: u64 = 0;
  let mut x31: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x30, &mut x31, 0x0, x14, x20);
  let mut x32: u64 = 0;
  let mut x33: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x32, &mut x33, x31, x28, x22);
  let mut x34: u64 = 0;
  let mut x35: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x34, &mut x35, x23, x19, (0x0 as u64));
  let mut x36: u64 = 0;
  let mut x37: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x36, &mut x37, x33, x2, x34);
  let mut x38: u64 = 0;
  let mut x39: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x38, &mut x39, x37, x3, x16);
  let mut x40: u64 = 0;
  let mut x41: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x40, &mut x41, 0x0, x32, (arg1[2]));
  let mut x42: u64 = 0;
  let mut x43: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x42, &mut x43, x41, x36, (0x0 as u64));
  let mut x44: u64 = 0;
  let mut x45: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x44, &mut x45, x43, x38, (0x0 as u64));
  let mut x46: u64 = 0;
  let mut x47: u64 = 0;
  fiat_p256_mulx_u64(&mut x46, &mut x47, x40, 0xffffffff00000001);
  let mut x48: u64 = 0;
  let mut x49: u64 = 0;
  fiat_p256_mulx_u64(&mut x48, &mut x49, x40, 0xffffffff);
  let mut x50: u64 = 0;
  let mut x51: u64 = 0;
  fiat_p256_mulx_u64(&mut x50, &mut x51, x40, 0xffffffffffffffff);
  let mut x52: u64 = 0;
  let mut x53: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x52, &mut x53, 0x0, x51, x48);
  let mut x54: u64 = 0;
  let mut x55: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x54, &mut x55, 0x0, x40, x50);
  let mut x56: u64 = 0;
  let mut x57: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x56, &mut x57, x55, x42, x52);
  let mut x58: u64 = 0;
  let mut x59: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x58, &mut x59, x53, x49, (0x0 as u64));
  let mut x60: u64 = 0;
  let mut x61: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x60, &mut x61, x57, x44, x58);
  let mut x62: u64 = 0;
  let mut x63: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x62, &mut x63, x39, (0x0 as u64), x17);
  let mut x64: u64 = 0;
  let mut x65: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x64, &mut x65, x45, x62, (0x0 as u64));
  let mut x66: u64 = 0;
  let mut x67: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x66, &mut x67, x61, x64, x46);
  let mut x68: u64 = 0;
  let mut x69: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x68, &mut x69, 0x0, x56, (arg1[3]));
  let mut x70: u64 = 0;
  let mut x71: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x70, &mut x71, x69, x60, (0x0 as u64));
  let mut x72: u64 = 0;
  let mut x73: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x72, &mut x73, x71, x66, (0x0 as u64));
  let mut x74: u64 = 0;
  let mut x75: u64 = 0;
  fiat_p256_mulx_u64(&mut x74, &mut x75, x68, 0xffffffff00000001);
  let mut x76: u64 = 0;
  let mut x77: u64 = 0;
  fiat_p256_mulx_u64(&mut x76, &mut x77, x68, 0xffffffff);
  let mut x78: u64 = 0;
  let mut x79: u64 = 0;
  fiat_p256_mulx_u64(&mut x78, &mut x79, x68, 0xffffffffffffffff);
  let mut x80: u64 = 0;
  let mut x81: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x80, &mut x81, 0x0, x79, x76);
  let mut x82: u64 = 0;
  let mut x83: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x82, &mut x83, 0x0, x68, x78);
  let mut x84: u64 = 0;
  let mut x85: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x84, &mut x85, x83, x70, x80);
  let mut x86: u64 = 0;
  let mut x87: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x86, &mut x87, x81, x77, (0x0 as u64));
  let mut x88: u64 = 0;
  let mut x89: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x88, &mut x89, x85, x72, x86);
  let mut x90: u64 = 0;
  let mut x91: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x90, &mut x91, x67, (0x0 as u64), x47);
  let mut x92: u64 = 0;
  let mut x93: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x92, &mut x93, x73, x90, (0x0 as u64));
  let mut x94: u64 = 0;
  let mut x95: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x94, &mut x95, x89, x92, x74);
  let mut x96: u64 = 0;
  let mut x97: fiat_p256_u1 = 0;
  fiat_p256_addcarryx_u64(&mut x96, &mut x97, x95, (0x0 as u64), x75);
  let mut x98: u64 = 0;
  let mut x99: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x98, &mut x99, 0x0, x84, 0xffffffffffffffff);
  let mut x100: u64 = 0;
  let mut x101: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x100, &mut x101, x99, x88, (0xffffffff as u64));
  let mut x102: u64 = 0;
  let mut x103: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x102, &mut x103, x101, x94, (0x0 as u64));
  let mut x104: u64 = 0;
  let mut x105: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x104, &mut x105, x103, x96, 0xffffffff00000001);
  let mut x106: u64 = 0;
  let mut x107: fiat_p256_u1 = 0;
  fiat_p256_subborrowx_u64(&mut x106, &mut x107, x105, (0x0 as u64), (0x0 as u64));
  let mut x108: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x108, x107, x98, x84);
  let mut x109: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x109, x107, x100, x88);
  let mut x110: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x110, x107, x102, x94);
  let mut x111: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x111, x107, x104, x96);
  out1[0] = x108;
  out1[1] = x109;
  out1[2] = x110;
  out1[3] = x111;
}

/*
 * The function fiat_p256_nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
#[inline]
pub fn fiat_p256_nonzero(out1: &mut u64, arg1: &[u64; 4]) -> () {
  let x1: u64 = ((arg1[0]) | ((arg1[1]) | ((arg1[2]) | ((arg1[3]) | (0x0 as u64)))));
  *out1 = x1;
}

/*
 * The function fiat_p256_selectznz is a multi-limb conditional select.
 * Postconditions:
 *   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 *   arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p256_selectznz(out1: &mut [u64; 4], arg1: fiat_p256_u1, arg2: &[u64; 4], arg3: &[u64; 4]) -> () {
  let mut x1: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x1, arg1, (arg2[0]), (arg3[0]));
  let mut x2: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x2, arg1, (arg2[1]), (arg3[1]));
  let mut x3: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x3, arg1, (arg2[2]), (arg3[2]));
  let mut x4: u64 = 0;
  fiat_p256_cmovznz_u64(&mut x4, arg1, (arg2[3]), (arg3[3]));
  out1[0] = x1;
  out1[1] = x2;
  out1[2] = x3;
  out1[3] = x4;
}

/*
 * The function fiat_p256_to_bytes serializes a field element in the Montgomery domain to bytes in little-endian order.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..31]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 */
#[inline]
pub fn fiat_p256_to_bytes(out1: &mut [u8; 32], arg1: &[u64; 4]) -> () {
  let x1: u64 = (arg1[3]);
  let x2: u64 = (arg1[2]);
  let x3: u64 = (arg1[1]);
  let x4: u64 = (arg1[0]);
  let x5: u64 = (x4 >> 8);
  let x6: u8 = ((x4 & (0xff as u64)) as u8);
  let x7: u64 = (x5 >> 8);
  let x8: u8 = ((x5 & (0xff as u64)) as u8);
  let x9: u64 = (x7 >> 8);
  let x10: u8 = ((x7 & (0xff as u64)) as u8);
  let x11: u64 = (x9 >> 8);
  let x12: u8 = ((x9 & (0xff as u64)) as u8);
  let x13: u64 = (x11 >> 8);
  let x14: u8 = ((x11 & (0xff as u64)) as u8);
  let x15: u64 = (x13 >> 8);
  let x16: u8 = ((x13 & (0xff as u64)) as u8);
  let x17: u8 = ((x15 >> 8) as u8);
  let x18: u8 = ((x15 & (0xff as u64)) as u8);
  let x19: u8 = (x17 & 0xff);
  let x20: u64 = (x3 >> 8);
  let x21: u8 = ((x3 & (0xff as u64)) as u8);
  let x22: u64 = (x20 >> 8);
  let x23: u8 = ((x20 & (0xff as u64)) as u8);
  let x24: u64 = (x22 >> 8);
  let x25: u8 = ((x22 & (0xff as u64)) as u8);
  let x26: u64 = (x24 >> 8);
  let x27: u8 = ((x24 & (0xff as u64)) as u8);
  let x28: u64 = (x26 >> 8);
  let x29: u8 = ((x26 & (0xff as u64)) as u8);
  let x30: u64 = (x28 >> 8);
  let x31: u8 = ((x28 & (0xff as u64)) as u8);
  let x32: u8 = ((x30 >> 8) as u8);
  let x33: u8 = ((x30 & (0xff as u64)) as u8);
  let x34: u8 = (x32 & 0xff);
  let x35: u64 = (x2 >> 8);
  let x36: u8 = ((x2 & (0xff as u64)) as u8);
  let x37: u64 = (x35 >> 8);
  let x38: u8 = ((x35 & (0xff as u64)) as u8);
  let x39: u64 = (x37 >> 8);
  let x40: u8 = ((x37 & (0xff as u64)) as u8);
  let x41: u64 = (x39 >> 8);
  let x42: u8 = ((x39 & (0xff as u64)) as u8);
  let x43: u64 = (x41 >> 8);
  let x44: u8 = ((x41 & (0xff as u64)) as u8);
  let x45: u64 = (x43 >> 8);
  let x46: u8 = ((x43 & (0xff as u64)) as u8);
  let x47: u8 = ((x45 >> 8) as u8);
  let x48: u8 = ((x45 & (0xff as u64)) as u8);
  let x49: u8 = (x47 & 0xff);
  let x50: u64 = (x1 >> 8);
  let x51: u8 = ((x1 & (0xff as u64)) as u8);
  let x52: u64 = (x50 >> 8);
  let x53: u8 = ((x50 & (0xff as u64)) as u8);
  let x54: u64 = (x52 >> 8);
  let x55: u8 = ((x52 & (0xff as u64)) as u8);
  let x56: u64 = (x54 >> 8);
  let x57: u8 = ((x54 & (0xff as u64)) as u8);
  let x58: u64 = (x56 >> 8);
  let x59: u8 = ((x56 & (0xff as u64)) as u8);
  let x60: u64 = (x58 >> 8);
  let x61: u8 = ((x58 & (0xff as u64)) as u8);
  let x62: u8 = ((x60 >> 8) as u8);
  let x63: u8 = ((x60 & (0xff as u64)) as u8);
  out1[0] = x6;
  out1[1] = x8;
  out1[2] = x10;
  out1[3] = x12;
  out1[4] = x14;
  out1[5] = x16;
  out1[6] = x18;
  out1[7] = x19;
  out1[8] = x21;
  out1[9] = x23;
  out1[10] = x25;
  out1[11] = x27;
  out1[12] = x29;
  out1[13] = x31;
  out1[14] = x33;
  out1[15] = x34;
  out1[16] = x36;
  out1[17] = x38;
  out1[18] = x40;
  out1[19] = x42;
  out1[20] = x44;
  out1[21] = x46;
  out1[22] = x48;
  out1[23] = x49;
  out1[24] = x51;
  out1[25] = x53;
  out1[26] = x55;
  out1[27] = x57;
  out1[28] = x59;
  out1[29] = x61;
  out1[30] = x63;
  out1[31] = x62;
}

/*
 * The function fiat_p256_from_bytes deserializes a field element in the Montgomery domain from bytes in little-endian order.
 * Preconditions:
 *   0 ≤ bytes_eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
#[inline]
pub fn fiat_p256_from_bytes(out1: &mut [u64; 4], arg1: &[u8; 32]) -> () {
  let x1: u64 = (((arg1[31]) as u64) << 56);
  let x2: u64 = (((arg1[30]) as u64) << 48);
  let x3: u64 = (((arg1[29]) as u64) << 40);
  let x4: u64 = (((arg1[28]) as u64) << 32);
  let x5: u64 = (((arg1[27]) as u64) << 24);
  let x6: u64 = (((arg1[26]) as u64) << 16);
  let x7: u64 = (((arg1[25]) as u64) << 8);
  let x8: u8 = (arg1[24]);
  let x9: u64 = (((arg1[23]) as u64) << 56);
  let x10: u64 = (((arg1[22]) as u64) << 48);
  let x11: u64 = (((arg1[21]) as u64) << 40);
  let x12: u64 = (((arg1[20]) as u64) << 32);
  let x13: u64 = (((arg1[19]) as u64) << 24);
  let x14: u64 = (((arg1[18]) as u64) << 16);
  let x15: u64 = (((arg1[17]) as u64) << 8);
  let x16: u8 = (arg1[16]);
  let x17: u64 = (((arg1[15]) as u64) << 56);
  let x18: u64 = (((arg1[14]) as u64) << 48);
  let x19: u64 = (((arg1[13]) as u64) << 40);
  let x20: u64 = (((arg1[12]) as u64) << 32);
  let x21: u64 = (((arg1[11]) as u64) << 24);
  let x22: u64 = (((arg1[10]) as u64) << 16);
  let x23: u64 = (((arg1[9]) as u64) << 8);
  let x24: u8 = (arg1[8]);
  let x25: u64 = (((arg1[7]) as u64) << 56);
  let x26: u64 = (((arg1[6]) as u64) << 48);
  let x27: u64 = (((arg1[5]) as u64) << 40);
  let x28: u64 = (((arg1[4]) as u64) << 32);
  let x29: u64 = (((arg1[3]) as u64) << 24);
  let x30: u64 = (((arg1[2]) as u64) << 16);
  let x31: u64 = (((arg1[1]) as u64) << 8);
  let x32: u8 = (arg1[0]);
  let x33: u64 = ((x32 as u64) + (x31 + (x30 + (x29 + (x28 + (x27 + (x26 + x25)))))));
  let x34: u64 = (x33 & 0xffffffffffffffff);
  let x35: u64 = ((x8 as u64) + (x7 + (x6 + (x5 + (x4 + (x3 + (x2 + x1)))))));
  let x36: u64 = ((x16 as u64) + (x15 + (x14 + (x13 + (x12 + (x11 + (x10 + x9)))))));
  let x37: u64 = ((x24 as u64) + (x23 + (x22 + (x21 + (x20 + (x19 + (x18 + x17)))))));
  let x38: u64 = (x37 & 0xffffffffffffffff);
  let x39: u64 = (x36 & 0xffffffffffffffff);
  out1[0] = x34;
  out1[1] = x38;
  out1[2] = x39;
  out1[3] = x35;
}

